

#include <stdio.h>
#include <string.h>

#include <stdint.h>

#define           poly     0x1021          /* crc-ccitt mask */

/* global variables */

    void update_crc(uint8_t);
    void finalize_crc();
    void obtain_crc();

uint8_t W[12];
uint16_t CRC;

void obtain_crc(void)
{
    uint8_t ch;
    uint16_t i;
    
/*	W[0] = 0xa8;
	W[1] = 0x78;
	W[2] = 0x27;
        W[3] = 0xa0;
	W[4] = 0x24;
	W[5] = 0x69;
	W[6] = 0xad;
	W[7] = 0xdc;
        W[8] = 0x61;
	W[9] = 0xa9;
	W[10] = 0x7d;
	W[11] = 0x5a;
	*/

    CRC = 0xffff;

    for (i=0; i<12; i++) {
        ch = W[i];
        update_crc(ch);
//	    printf("CRC = %04X, Length = %d, Data = 0x%x\n", CRC, i+1, ch);
    }
    finalize_crc();
//    printf("final CRC = %04X,  Length = %u\n", CRC, i);
}

void update_crc(uint8_t ch)
{
    uint16_t i, v, xor_flag;

    /*
    Align test bit with leftmost bit of the message byte.
    */
    v = 0x80;

    for (i=0; i<8; i++)
    {
        if (CRC & 0x8000)
        {
            xor_flag= 1;
        }
        else
        {
            xor_flag= 0;
        }
        CRC = CRC << 1;

        if (ch & v)
        {
            /*
            Append next bit of message to end of CRC if it is not zero.
            The zero bit placed there by the shift above need not be
            changed if the next bit of the message is zero.
            */
            CRC= CRC + 1;
        }

        if (xor_flag)
        {
            CRC = CRC ^ poly;
        }

        /*
        Align test bit with next bit of the message byte.
        */
        v = v >> 1;
    }
}

void finalize_crc()
{
    unsigned short i, xor_flag;

    for (i=0; i<16; i++)
    {
        if (CRC & 0x8000)
        {
            xor_flag= 1;
        }
        else
        {
            xor_flag= 0;
        }
        CRC = CRC << 1;

        if (xor_flag)
        {
            CRC = CRC ^ poly;
        }
    }
}

