/* ... "FEBEX_readout.h" ...  FEBEX specific definitions ... */

#ifndef _FEBEXREADOUT_H
#define _FEBEXREADOUT_H


#ifndef FEBEXPRESENT
#define FEBEXPRESENT
#endif


#ifndef MIN_MODULE
#define MIN_MODULE 1
#define MAX_MODULE 64
#endif

#define FEBEXFIFOBUFFERLENGTH  512

unsigned int FEBEX_FifoBuffer[MAX_MODULE+1][FEBEXFIFOBUFFERLENGTH];
unsigned int FEBEX_FifoBufferPtr[MAX_MODULE+1];

void FEBEX_init_connection ();
void FEBEX_term_connection ();


//    procedure prototypes
void febex_readevent ();
void febex_readdata ();
void febex_formatevent ();

void febex_formatMBSdata ();
void febex_formatJLdata ();

void febex_init_connection ();
void febex_term_connection ();
void febex_go_connection ();

/*    options for data In/Out;  These are all set via NetVars  */

int FEBEX_PexorEnable = 1;   /* enable data read from /dev/pexor  */

int FEBEX_Data_In_Enable = 0;   /* enable data read from file */
int FEBEX_Data_Out_Enable = 0;  /* enable data write to file */

int FEBEX_DataFormat = 0;       /* data format variant (=0 is original mbs format)  */
int FEBEX_Do_DataRead = 1;      /*  enable call to febex_readevent()   */
int FEBEX_Do_DataFormat = 1;    /*  enable call to febex_formatdata()  */

int FEBEX_TestPatternMode = 0;       /*  0 or 1  */
int FEBEX_TokenMode = 0;             /*  0 or 2  */

int FEBEX_MWDFormat = 1;     /*  0 or 1 */

uint32_t FEBEX_ReadOutDelay = 0;

//    uint32_t EnergyLow = 0;
//    uint32_t EnergyHigh = 2147483648;   /*  0x7fffffff  */

uint32_t FEBEX_EnergyLow  = 000000000;
uint32_t FEBEX_EnergyHigh = 300000000;
uint32_t FEBEX_BinSize    =   10000;

char FEBEX_Data_Base[64];
char FEBEX_DataIn_File[64];
char FEBEX_DataOut_File[64];

FILE * FEBEX_DataInHandle;
FILE * FEBEX_DataOutHandle;

static int fd_pex;     /*    for /dev/pexor; return from mbspex_open  */

#define NUM_SFP     4    /*  per PEXOR module  -  number of FEBEX ADC crates */
#define MAX_SLAVE   16   /*  per SFP - number of FEBEX ADCs per crate  */
#define NUM_ADCS 16      /*  per FEBEX module  */

#define DMASIZE 640000  /* bytes */

char fname[100];

static unsigned long dmasize;

static int databuffer[DMASIZE/4];
static int databufferlen;

unsigned int * evntbuffer;
int evntbufferlen;       /*  units of 32 bits  */


//    control variables

int Counter=0;
int Value=0;
int Data = 0;

    int sfpID;
    int trigID;
    int modID;
    int chID;
    
    int Energy[NUM_ADCS];
    int Time[NUM_ADCS];
    





#endif



