
#define VERSION "FEBEX"
#define RELEASE "1"

#define BUILD __DATE__
#define BTIME __TIME__

#ifdef LINUX64
#define OS "Linux64"
#else
#define OS "Linux"
#endif


#define USEINT

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>

#include <sys/file.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <errno.h>

#include <signal.h>
#include <setjmp.h>

#include "common.h"

#include "liblinuxDL.h"
#include "linux.h"

#include "egmsg.h"

#include "FEBEX_DACQ.h"
#include "DACQ.h"

#include "outputformats.h"

#include "netvars.h"
#include "buffers.h"
#include "report.h"
#include "sigbus.h"
#include "signals.h"
#include "xfer.h"

#include "histogramming.h"
#include "DACQ_histogramming.h"
#include "FEBEX_histogramming.h"

#include "readout.h"
#include "FEBEX_readout.h"
#include "FEBEX_control.h"
#include "FEBEX_stat.h"

void VME_int_setup()
{
};                              /*    VME not used by this version   */

void VME_dma_setup()
{
};

/* ---------  end of variables definitions ... start of code ----------- */

#include "report.c"
#include "signals.c"
#include "sigbus.c"

#include "DACQ_stat.c"

#include "DACQ_exec.c"

/* --------------------------------------------------------------------- */

#include "FEBEX_config.c"

/* -------------------------------*/
#include "FEBEX_readout.c"
#include "FEBEX_formatdata.c"

#include "DACQ_handle_signal.c"

#include "FEBEX_interrupt.c"

#include "DACQ_histogramming.c"
#include "FEBEX_histogramming.c"

#include "xfer_event.c"

#include "xfer_block.c"

#include "main.c"

/* --------------------------------------------------------------------- */
