


#ifndef _DACQ_H
#define _DACQ_H



/*   program states   */
#define IDLE 0     /*  state after program load  */
#define READY 1    /*  state after SETUP  */
#define STOPPED 1  /*  DA stopped -  same as READY  */
#define GOING 2 
#define FLUSH 3   /*   used during STOP  */

/*    pause states   */
#define RUNNING 0
#define PAUSING 4+256
#define PAUSED  5+256

#ifndef WIN32
#include <sys/wait.h>
#endif

/*    common statistics and rates counters  */

#define INC 3
#define INC2D 3
#define TXBUFFERS 4
#define TXTOTALCOUNT 5
#define NULLEVENTS 6
#define TOOBIG 7
#define TXERR 14
#define TXWAIT 15

#define TX2BUFFERS 16
#define TX2TOTALCOUNT 17
#define TX2ERR 18
#define TX2WAIT 19


#ifndef NUMOVERLAPS
#define NUMOVERLAPS 2
#endif

#ifndef USETHREADS
#define NUMTHREADS 1
#endif

#ifndef NUMDATASTREAMS
#define NUMDATASTREAMS 2
#endif


/*  procedure prototypes  - those not elsewhere */
void DACQ_handle_signal();

void DACQ_ClearStats();
void DACQ_UpdateStats();

void DACQ_InitHeartBeat();

#ifdef USETHREADS
int DACQ_HeartBeatPulse[NUMTHREADS+1];
#else
int DACQ_HeartBeatPulse;
#endif

long long DACQ_HeatBeatTime = 0;

#define PUSHREQ 1

//int xfer_pushDisable = 0;
//int xfer_pushRequired = 0;    /*  used by FLUSH logic between Heartbeat thread and main thread */

//void xfer_flush(int);

#ifdef WIN32

DWORD mypid;

HANDLE hStdout;
void ErrorHandler (LPTSTR);

#define CORETHREADS 8    // main; heartbeat; stats; rates etc
#define HEARTBEAT NUMTHREADS+1
#define STATISTICS NUMTHREADS+2
#define STATRATE NUMTHREADS+3
#define HITRATE NUMTHREADS+4
#define DACQ NUMTHREADS+5
#define MON NUMTHREADS+6

int NumThreads = 0;
HANDLE hThreadArray[CORETHREADS+NUMTHREADS+1];
DWORD dwThreadIdArray[CORETHREADS+NUMTHREADS+1];
int pDataArray[CORETHREADS+NUMTHREADS+1];
int ThreadInUse[CORETHREADS+NUMTHREADS+1];

#else
pid_t mypid;
#endif


/*  optional application specfic actions   */
#ifndef USEAPPLACTIONS
void ApplAction1(char *p) {};
void ApplAction2(char *p) {};
void ApplAction3(char *p) {};
#else
void ApplAction1(char *);
void ApplAction2(char *);
void ApplAction3(char *);
#endif


#endif
