
#ifndef _VME_H
#define _VME_H

#ifdef LINUX
#include <vme/vme.h>
#include <vme/vme_api.h>
#include <uvme.h>
#else
#include <sys/include/io/uvme.h>
#endif

#define BUF_NAME "/DACQ_DMABUFF"

#ifndef LINUX

#define VMEINT_DEVICE "/dev/vmeint"

int vfd;

#define PCI_OFFSET 0x80000000
#endif

//struct dma_flags {
//    unsigned long pci_addr;    /* pci address */
//    unsigned long vme_addr;    /* vme address */
//    unsigned long byte_cnt;    /* byte count  */
//    int direction;             /* VME2PCI or PCI2VME */
//    int vdw;                   /* vmebus max datawidth */
//    int vas;                   /* vmebus address space */
//    int am_pgm;                /* AM code pgm/data */
//    int am_sup;                /* AM code sup/np */
//    int vct;                   /* Vmebus cycle type */
//    int ld64en;                /* enable 64bit pci transactions */
//};


/*
direction     VME2PCI or PCI2VME
vdw           D_VDW_08, D_VDW_16, D_VDW_32 or D_VDW_64
vas           D_VAS_16, D_VAS_24 or D_VAS_32
am_pgm        AM_DATA or AM_PGM
am_sup        AM_NP or AM_SUP
vct           VCT_SC or VCT_SCBT
ld64en        LD64EN or LD64DIS
*/

#if defined DMA16
#define D_VDW_WIDTH D_VDW_16
#define VDW 16
#elif defined  DMA64
#define D_VDW_WIDTH D_VDW_64
#define VDW 64
#else /* if defined  DMA32 */
#define D_VDW_WIDTH D_VDW_32    /* default  */
#define VDW 32
#endif

#ifdef DMAA24
#define D_VAS_WIDTH D_VAS_24
#define VAS 24
#else
#define D_VAS_WIDTH D_VAS_32    /*  default  */
#define VAS 32
#endif

#ifdef DMABLT
#define VCT_SC_BT VCT_SCBT
#define VCT "BLT"
#else
#define VCT_SC_BT VCT_SC        /*  default  */
#define VCT "SC"
#endif

#ifndef LINUX
struct dma_flags DMA_flags = {0, 0, 0, VME2PCI, D_VDW_WIDTH, D_VAS_WIDTH, AM_DATA, AM_NP, VCT_SC_BT, LD64EN};
#else
struct dma_flags DMA_flags = {0, 0, 0, 0, D_VDW_WIDTH, D_VAS_WIDTH, 0, 0, VCT_SC_BT, 0};
#endif

#ifndef LINUX
int PCIAddressBase;
#else
vme_bus_handle_t VME_bus_handle;
vme_dma_handle_t VME_dma_handle;
vme_interrupt_handle_t VME_interrupt_handle;
#endif

int PCIAddressOffset=0;

/*    VME address space  virtual addresses    */
int VMEA16Base = -1;
int VMEA24Base = -1;
int VMEA32Base = -1;

int VMEA16Size;
int VMEA24Size;
int VMEA32Size;

/*    VME address space  real addresses    */
int VMEA16VMEBase;
int VMEA24VMEBase;
int VMEA32VMEBase;

void VME_int_setup();
void VME_dma_setup();

int DMAInhibit = 0;

void VME_xfer(void *, unsigned int);
int VME_dma_errcode = 0;

#endif
