
/*

    this code insert is the main data acquisition procedure
    includes the startup sequence and the DA loop
    
*/

void DACQ_exec()
{

  volatile int yyy=0;
  int xxx;
  int i, j;

   signal_setup();

   VME_int_setup();

#ifndef WIN32

/*    setup trap for SIGBUS errors  */
   sigtrapset ("Error detected setting up DACQ module - Please check your hardware");

   switch (setjmp(jmpEnv)) {
      case 0:
         break;
      case 1:
         sprintf (message, "SIGBUS ERROR - %s", sigtrapreason);
         reportandquit();
      case 2:
         sprintf (message, "SIGSEGV ERROR - %s", sigtrapreason);
         reportandquit();
   }

#endif

   DACQ_setup();

 DACQ_Init_spectra();
#ifdef HIST2D
 DACQ_Init_spectra2D();
#endif

   DACQ_zero();

#ifndef WIN32

/*    setup trap for SIGBUS errors  */
   sigtrapset ("Error detected during startup - Please check installation");

   switch (setjmp(jmpEnv)) {
      case 0:
         break;
      case 1:
         sprintf (message, "SIGBUS ERROR - %s", sigtrapreason);
         reportandquit();
      case 2:
         sprintf (message, "SIGSEGV ERROR - %s", sigtrapreason);
         reportandquit();
   }

#endif

   VME_dma_setup();

  /* Set initial state ... */

  *dacq_State = IDLE;
  DACQ_State = IDLE;

  if (XferMode != 4) {

#ifndef WIN32
 
/*    setup trap for SIGBUS errors  */
   sigtrapset ("Error detected during Tape Server initialisation - Please check installation");

   switch (setjmp(jmpEnv)) {
      case 0:
         break;
      case 1:
         sprintf (message, "SIGBUS ERROR - %s", sigtrapreason);
         reportandquit();
      case 2:
         sprintf (message, "SIGSEGV ERROR - %s", sigtrapreason);
         reportandquit();
      case 3:
         sprintf (message, "SIGPIPE ERROR - %s", sigtrapreason);
         reportandquit();
   }

#endif

   if (*dacq_TxInit == 0) {

   if (strcmp(TS_Server,"") == 0)
   {
      printf ("Data Acquisition without storage server\n");
      *dacq_TxEnable = 0;
   } else {
#ifndef GANIL
      printf ("Data Acquisition using storge server %s on port %d\n", TS_Server, TS_Port);

      printf ("Initialising communication with storage server\n");
      (void) transferSetUser(0);
      (void) transferBlockSize(Output_BufferSize);
      (void) transferMode(XferMode);
      if (TS_Port != 0) (void) transferPort(TS_Port);
      (void) transferUseOverlap(Xfer_Overlap);
      (void) transferBlockMode(Xfer_BlockMode);
      (void) transferNice(Xfer_Priority);
      (void) transferInit(TS_Server);
#else
   if (XferMode == 5) {
      printf ("Data Acquisition using GANIL server with data source %s\n", TS_Server);

      printf ("Initialising communication with GANIL server\n");

      (void) GANILtransferUseOverlap(Xfer_Overlap);
      (void) GANILtransferNice(Xfer_Priority);
      (void) GANILtransferInit(TS_Server);
   } else {
      printf ("Data Acquisition using storage server %s on port %d\n", TS_Server, TS_Port);

      printf ("Initialising communication with storage server\n");
      (void) transferSetUser(0);
      (void) transferBlockSize(Output_BufferSize);
      (void) transferMode(XferMode);
      if (TS_Port != 0) (void) transferPort(TS_Port);
      (void) transferUseOverlap(Xfer_Overlap);
      (void) transferBlockMode(Xfer_BlockMode);
      (void) transferNice(Xfer_Priority);
      (void) transferInit(TS_Server);
   }
#endif
      *dacq_TxEnable = 1;
   }


   if (strcmp(TS2_Server,"") == 0)
   {
      *dacq_Tx2Enable = 0;
   } else {
#ifndef GANIL
      printf ("Data Acquisition using storage server %s on port %d\n", TS2_Server, TS2_Port);

      printf ("Initialising communication with storage server #2\n");
      (void) transferSetUser(1);
      (void) transferBlockSize(Output_BufferSize);
      (void) transferMode(XferMode);
      if (TS2_Port != 0) (void) transferPort(TS2_Port);
      (void) transferUseOverlap(Xfer_Overlap);
      (void) transferBlockMode(Xfer_BlockMode);
      (void) transferNice(Xfer_Priority);
      (void) transferInit(TS2_Server);
#else
   if (XferMode == 5) {
      printf ("Data Acquisition using GANIL server with data source %s\n", TS2_Server);

      printf ("Initialising communication with GANIL server\n");
      (void) GANILtransferUseOverlap(Xfer_Overlap);
      (void) GANILtransferNice(Xfer_Priority);
      (void) GANILtransferInit(TS2_Server);
   } else {
      printf ("Data Acquisition using storage server %s on port %d\n", TS2_Server, TS2_Port);

      printf ("Initialising communication with storage server #2\n");
      (void) transferSetUser(1);
      (void) transferBlockSize(Output_BufferSize);
      (void) transferMode(XferMode);
      if (TS2_Port != 0) (void) transferPort(TS2_Port);
      (void) transferUseOverlap(Xfer_Overlap);
      (void) transferBlockMode(Xfer_BlockMode);
      (void) transferNice(Xfer_Priority);
      (void) transferInit(TS2_Server);
   }
#endif
      *dacq_Tx2Enable = 1;
   }

   }   /*  end of *dacq_TxInit == 0  */

   if (*dacq_TxInit == 1) {

      *dacq_TxEnable = 0;
      *dacq_Tx2Enable = 0;
   }

   }   /* end of XferMode != 4 */


   sprintf(message, "%s Data Acquisition now all ready to start", VERSION);
   printf ("%s\n", message);
   msgDefineMessage (0, MSG_C_EB, MSG_S_INFORMATION, NULL, message);

#ifndef WIN32

/*    setup trap for SIGBUS and SIGSEGV errors  */

   sigtrapset ("Error detected during data acquisition");

   switch (setjmp(jmpEnv)) {
      case 0:
         sprintf(message, "SIGBUS, SIGSEGV and SIGPIPE traps setup");
         break;
      case 1:
         sprintf (message, "SIGBUS ERROR - %s: location=%d", sigtrapreason, Location);
         sigbuscounter++;
         if (sigbuscounter < SIGBUSLIMIT) break;
         report();
         sprintf (message, "too many errors are occurring - pausing");
         PauseState = 1;
         *dacq_State = STOPPED;
         if (sigbuscounter < TRAPLIMIT) break;
         report();
         sprintf (message, "too many errors are occurring; you must find and fix the cause - exiting");
         reportandquit();
      case 2:
         sprintf (message, "SIGSEGV ERROR - %s: location=%d", sigtrapreason, Location);
         sigsegvcounter++;
         if (sigsegvcounter < SIGSEGVLIMIT) break;
         report();
         sprintf (message, "too many errors are occurring - pausing");
         PauseState = 1;
         *dacq_State = STOPPED;
         if (sigsegvcounter < TRAPLIMIT) break;
         report();
         sprintf (message, "too many errors are occurring; you must find and fix the cause - exiting");
         reportandquit();
      case 3:
         sprintf (message, "SIGPIPE ERROR - %s: location=%d", sigtrapreason, Location);
         sigpipecounter++;
         if (sigpipecounter < SIGPIPELIMIT) break;
         report();
         sprintf (message, "too many errors are occurring - pausing");
         PauseState = 1;
         *dacq_State = STOPPED;
         if (sigpipecounter < TRAPLIMIT) break;
         report();
         sprintf (message, "too many errors are occurring; you must find and fix the cause - exiting");
         reportandquit();
   }

   report();

#endif

  for (;;)
  {

    (*dacq_Alive)++;       /* so this can be detected  */

    if(*dacq_Trace > 8) printf("waiting for signal\n");

/*
      For modules which do not generate interrupts when data is available 
      (such as the GRT4P and S9418 modules) we can only loop looking at the
      data fifo waiting for data to arrive    -    but only when GOING!
      We do this by simulating receipt of a SIGINT signal in order to
      keep the program logic unchanged.
      The variable PollTicks can be used to control the rate at which the VME module is accessed. 
      It is also then a flag to indicate that polling is to be used (PollTicks > 32).
      PollTicks less than 32 are used as an additional parameter by the X2VB test task
*/

    if (*dacq_PollTicks > 32 && ((*dacq_State) & 255) == GOING && signal_occurred == 0)
    {

         for (j=0; j<(*dacq_PollTicks-32); j++) {xxx=yyy;}   /*  a short delay  */
         if (((*dacq_State) & 255) == GOING && signal_occurred == 0 && *exec_Action == 0) sigint_received (SIGINT);
    }

#ifdef FLUSHREQ
    if (DACQ_flushRequired == 1) {DACQ_flushRequired = 0; for (i=0; i<NUMDATASTREAMS; i++) {DACQ_flush(i);}}
#endif

#ifdef PUSHREQ
    if (xfer_pushRequired == 1) {xfer_pushRequired = 0; for (i=0; i<NUMDATASTREAMS; i++) {xfer_push(i);}}
#endif

    cond_wait_for_signal();

    DACQ_handle_signal();
    
    if(*dacq_Trace > 8) printf("received signal %d.\n",  Signal);

  }
}
