



/* --------------------------------------------------------------------- */

void DACQ_handle_signal()
{
   int currentstate;
   int status;
   unsigned int item;
   int len;
   char * ptr;
   unsigned int * response;
   int type, m;
#ifndef WIN32
   int i;
#endif
   int j,k,c;

#ifdef USEINT
   unsigned int *ptr1, *ptr2;
   unsigned int data;
#endif

#ifdef USESHORT
   unsigned short *ptr1, *ptr2;
   unsigned short data;
#endif

   void histogram_data();

   int verbose = 0;

    unsigned int * dptr;

   currentstate = DACQ_State;

    switch (Signal) {

       case 0:
           break;

       case SIGUSR1:

/*    Signal from the GUI - look for the required action  */

           if(*dacq_Trace == 1) printf("received SIGUSR1 - action %d\n", *exec_Action);

           switch (*exec_Action) {
               case  0:
                   break;
               case  1:
                   *dacq_State = STOPPED;
                   DACQ_State = STOPPED;
                   PauseState = 0;
                   if (currentstate != GOING) break;
                   DACQ_stop();
                   for (i=0; i<NUMDATASTREAMS; i++) {
                       xfer_event((i << 4) + 1);         /* output any STOP marker */
                       xfer_block(i);          /*   output any partially full event block   */
                   }
#ifndef WIN32
                   waitpid(-1,&status,WNOHANG);     /* get rid of any dead test tasks */
#endif
                   break;
               case  2:
                   PauseState = 0;
                   if (currentstate != STOPPED) break;
                   DACQ_ClearStats();
                   EventNumber = 0;
                   EventNumberMSW = 0; EventNumberLSW = 0;
                   EventTagH = 0; EventTagM = 0; EventTagL = 0;
#ifndef WIN32
                   sigbuscounter = 0;
                   sigsegvcounter = 0;
                   sigpipecounter = 0;
#endif
                   xfer_pushDisable = 0;
                   DACQ_go();
                   *dacq_State = GOING;
                   DACQ_State = GOING;
                   for (i=0; i<NUMDATASTREAMS; i++) {
                       insert_block_header(i);
                   }
                   xfer_event(2);        /*  output any START marker */
                   break;
               case  3:
                   if (currentstate == GOING) break;
                   DACQ_setup();
                   *dacq_State = READY;
                   break;
               case  4:
                   DACQ_Get_spectra(exec_Parameter);
                   break;
               case  5:
                   DACQ_format(exec_Parameter);
                   break;
               case  6:
                   DACQ_zero();
                   break;
               case  7:
                   DACQ_ClearStats();
                   break;
               case  8:
                   DACQ_UnGet_spectra();
#ifdef HIST2D
                   DACQ_UnGet_spectra2D();     /*  unmap all 2D histograms  */
#endif
                   break;
               case  9:
                   *dacq_State = STOPPED;
                   DACQ_State = STOPPED;
                   DACQ_reset();
#ifndef WIN32
                   waitpid(-1,&status,WNOHANG);     /* get rid of any dead test tasks */
#endif
                   break;
               case  10:
                   DACQ_Get_spectrum(exec_Parameter);
                   break;
               case  11:
                   DACQ_UnGet_spectrum(exec_Parameter);
                   break;
               case  12:
                   ClearConfig();
                   break;
               case  13:
                   DefineConfig(exec_Parameter);
                   break;
               case  14:
#ifdef VMEPRESENT
                   VME_DefineConfig(exec_Parameter);
#endif
                   break;
               case  15:
#if (defined(D2VB) || defined(F2VB))
                   if (currentstate != GOING) break;
                   X2VB_flush();
                   DACQ_State = FLUSH;
#endif
                   break;
               case 16:
                   DACQ_Init_spectra();     /*  initialise histogram table  */
#ifdef HIST2D
                   DACQ_Init_spectra2D();     /*  initialise histogram table  */
#endif
                   break;
               case  17:
#ifdef HIST2D
                   DACQ_Get_spectrum2D(exec_Parameter);
#endif
                   break;
               case  18:
#ifdef HIST2D
                   DACQ_UnGet_spectrum2D(exec_Parameter);
#endif
                   break;
               default:
                   printf("Undefined action requested SIGUSR1 (%d)\n", *exec_Action);
                   break;
           }
           *exec_Signal = 0;   /* clear signal */
           *exec_Action = 0;    /* and clear Action  */
           break;

       case SIGUSR2:

/*    Signal from the GUI - look for the required action  */

           if(*dacq_Trace == 1) printf("received SIGUSR2 - action %d\n", *exec_Action);

           switch (*exec_Action) {
               case  0:
                   break;
               case  1:
#ifndef GANIL
                   (void) transferSetUser(0);
                   transferClose();
                   if (XferMode == 4) {*dacq_TxEnable = 0;}
#else
   if (XferMode == 5) {
                   GANILtransferClose();
   } else {
                   (void) transferSetUser(0);
                   transferClose();
   }
#endif
                   break;
               case  2:
#ifndef GANIL
                   (void) transferSetUser(1);
                   transferClose();
                   if (XferMode == 4) {*dacq_Tx2Enable =0;}
#else
   if (XferMode == 5) {
                   GANILtransferClose();
   } else {
                   (void) transferSetUser(1);
                   transferClose();
   }
#endif
                   break;
               case  3:
                   readNetString("TS_Server",0 , 1, TS_Server);
                   readNetInt("TS_Port", 0 , 1, &TS_Port);
#ifndef GANIL
                   printf ("Initialising communication with storage server %s on port %d\n", TS_Server, TS_Port);
                   (void) transferSetVerbose(verbose);
                   (void) transferSetUser(0);
                   (void) transferBlockSize(Output_BufferSize);
                   (void) transferMode(XferMode);
                   if (TS_Port != 0) (void) transferPort(TS_Port);
                   (void) transferUseOverlap(Xfer_Overlap);
                   (void) transferBlockMode(Xfer_BlockMode);
                   (void) transferNice(Xfer_Priority);
                   (void) transferInit(TS_Server);
                   status = transferStatus();
                   if (/*XferMode == 4 &&*/ status == 0) {*dacq_TxEnable = 0;} else {*dacq_TxEnable = 1;}
#else
   if (XferMode == 5) {
      printf ("Data Acquisition using GANIL server with data source %s\n", TS_Server);

      printf ("Initialising communication with GANIL server\n");
      (void) GANILtransferUseOverlap(Xfer_Overlap);
      (void) GANILtransferNice(Xfer_Priority);
      (void) GANILtransferInit(TS_Server);
   } else {
      printf ("Data Acquisition using storage server %s on port %d\n", TS_Server, TS_Port);

      printf ("Initialising communication with storage server\n");
      (void) transferSetVerbose(verbose);
      (void) transferSetUser(0);
      (void) transferBlockSize(Output_BufferSize);
      (void) transferMode(XferMode);
      if (TS_Port != 0) (void) transferPort(TS_Port);
      (void) transferUseOverlap(Xfer_Overlap);
      (void) transferBlockMode(Xfer_BlockMode);
      (void) transferNice(Xfer_Priority);
      (void) transferInit(TS_Server);
   }
#endif
                   break;
               case  4:
                   PrintConfig();
                   break;
               case  5:
#ifndef WIN32
                   i = fork();                /*  fork to create test generator task  */
                   if (i == 0) {DACQ_test(); exit(16);}
#endif
                   break;
               case  6:
#ifndef GANIL
                   readNetString("TS2_Server",0 , 1, TS2_Server);
                   readNetInt("TS2_Port", 0 , 1, &TS2_Port);
                   printf ("Initialising communication with storage server %s on port %d\n", TS2_Server, TS2_Port);
                   (void) transferSetVerbose(verbose);
                   (void) transferSetUser(1);
                   (void) transferBlockSize(Output_BufferSize);
                   (void) transferMode(XferMode);
                   if (TS2_Port != 0) (void) transferPort(TS2_Port);
                   (void) transferUseOverlap(Xfer_Overlap);
                   (void) transferBlockMode(Xfer_BlockMode);
                   (void) transferNice(Xfer_Priority);
                   (void) transferInit(TS2_Server);
                   status = transferStatus();
                   if (/*XferMode == 4 &&*/ status == 0) {*dacq_Tx2Enable = 0;} else {*dacq_Tx2Enable = 1;}
#else
   if (XferMode == 5) {
      printf ("Data Acquisition using GANIL server with data source %s\n", TS2_Server);

      printf ("Initialising communication with GANIL server\n");
      (void) GANILtransferUseOverlap(Xfer_Overlap);
      (void) GANILtransferNice(Xfer_Priority);
      (void) GANILtransferInit(TS2_Server);
   } else {
      printf ("Data Acquisition using storage server %s on port %d\n", TS2_Server, TS2_Port);

      printf ("Initialising communication with storage server\n");
      (void) transferSetVerbose(verbose);
      (void) transferSetUser(1);
      (void) transferBlockSize(Output_BufferSize);
      (void) transferMode(XferMode);
      if (TS2_Port != 0) (void) transferPort(TS2_Port);
      (void) transferUseOverlap(Xfer_Overlap);
      (void) transferBlockMode(Xfer_BlockMode);
      (void) transferNice(Xfer_Priority);
      (void) transferInit(TS2_Server);
   }
#endif
                   break;
               case 7:
                   PauseState = (PauseState+1)&1;      /*  a toggle used to pause readout for diagnostics  */
                   break;
               case 8:                                 /*   start storage of RAW data for diagnostic use  */
                   readNetString("RawDataStorage",0 , 1, RawDataStorage);
                   RawFilehandle = fopen(RawDataStorage,"w");
                   printf("Raw data storage on %s (%d)\n", RawDataStorage, RawFilehandle);
                   break;
               case 9:                                 /*   end storage of RAW data  */
                   fclose(RawFilehandle);
                   RawFilehandle =0;
                   break;
               case 10:                              /*  start "User" event  */
                   if (currentstate != GOING) break;
                   UserEventBufferlen = 0;

                   User_FifoBuffer[User_FifoBufferPtr] = 0x55aaaa55;
                   if (++User_FifoBufferPtr == FIFOBUFFERLENGTH) User_FifoBufferPtr = 0;

                   break;
               case 11:                              /*  define "User" event data  */
                   if (currentstate != GOING) break;
                   ptr1 = &UserEventBuffer[UserEventBufferlen];

                   ptr = exec_Parameter;
                   while (*ptr == ' ') ptr++;   /* step over leading space characters  */

                   while ((unsigned int)(ptr - exec_Parameter) < strlen(exec_Parameter)) {
                       status = sscanf(ptr, "%x", &item);
                       if (status != 1) break;     /* end of information  */
#ifdef USEINT
                       *ptr1++ = item;         /*  add data item to the User event */
#endif
#ifdef USESHORT
                       *ptr1++ = (unsigned short)item;         /*  add data item to the User event */
#endif
                       UserEventBufferlen++;
                       if ((ptr = strchr(ptr, ' ')) == NULL) break;  /* no more data items  */
                       while (*ptr == ' ') ptr++;   /* step over embedded multiple space characters  */
                   }
                   break;
               case 12:                              /*  end "User" event  */
                   if (currentstate != GOING) break;

                   ptr1 = EventBufferAddr;           /* copy event data from the User buffer to the normal buffer  */
                   ptr2 = UserEventBufferAddr;
                   len = UserEventBufferlen;
                   if (len > 0) {
                        while (len--) {*ptr1++ = *ptr2++;}
                   }
                   EventBufferLen = UserEventBufferlen;

                   dptr = (unsigned int *)UserEventBufferAddr;  /* copy into diagnostic buffer */
#ifdef USESHORT
                   len = UserEventBufferlen/2;
#endif
#ifdef USEINT
                   len = UserEventBufferlen;
#endif
                   if (len > 0) {
                        while (len--) {
                           User_FifoBuffer[User_FifoBufferPtr] = *dptr++;
                           if (++User_FifoBufferPtr == FIFOBUFFERLENGTH) User_FifoBufferPtr = 0;
                        }
                   }
 
                   histogram_data();
                   xfer_event(0);
                   break;
               case 13:
#ifndef GANIL
                   transferSetVerbose(1);
#else
                   if (XferMode == 5) {
                       (void) GANILtransferSetVerbose(1);
                   } else {
                       transferSetVerbose(1);
                   }
#endif
                   break;
               case 14:
#ifndef GANIL
                   transferSetVerbose(0);
#else
                   if (XferMode == 5) {
                       (void) GANILtransferSetVerbose(0);
                   } else {
                       transferSetVerbose(0);
                   }
#endif
                   break;
               case 16:
                   ApplAction1(exec_Parameter);
                   break;
               case 17:
                   ApplAction2(exec_Parameter);
                   break;
               case 18:
                   ApplAction3(exec_Parameter);
                   break;
               case 19:               /*  diagnostics  */
                   response = (unsigned int *) exec_Response;
                   *response = 0xaa5555aa;   /*  in case nothing else  */
                   if (currentstate != GOING) break;   /*  no diagnostics when not GOING - no data */
                   sscanf(exec_Parameter, "%d %d", &type, &m);
                   switch (type) {
                       case 1:          /*  caen   */
#ifdef CAENPRESENT
                         if (CAEN_Module[m] == 0) break;

                         *response++ = (unsigned int) CAEN_Type[m];
                         for (k = 1, j = CAEN_FifoBufferPtr[m]; k < FIFOBUFFERLENGTH; k++) {
                             *response++ = CAEN_FifoBuffer[m][j];
                             if (++j == FIFOBUFFERLENGTH) j = 0;
                         }
                         *response++ = 0xaa5555aa;
#endif
                         break;
                       case 2:          /*  s9418  */
#ifdef S9418PRESENT
                         if (S9418_Module[m] == 0) break;

                         for (k = 0, j = S9418_FifoBufferPtr[m]; k < FIFOBUFFERLENGTH; k++) {
                             *response++ = S9418_FifoBuffer[m][j];
                             if (++j == FIFOBUFFERLENGTH) j = 0;
                         }
                         *response++ = 0xaa5555aa;
#endif
                         break;
                         
                       case 3:          /*  adc3214   */
#ifdef XDC3214PRESENT
                         if (XDC3214_Module[m] == 0) break;

                         for (k = 0, j = XDC3214_FifoBufferPtr[m]; k < FIFOBUFFERLENGTH; k++) {
                             *response++ = XDC3214_FifoBuffer[m][j];
                             if (++j == FIFOBUFFERLENGTH) j = 0;
                         }
                         *response++ = 0xaa5555aa;
#endif
                         break;
			 
                       case 4:          /*  FEBEX4   */
#ifdef FEBEXPRESENT
			 
			 m=0;
			 

//                         for (k = 0, j = FEBEX_FifoBufferPtr[m]; k < FIFOBUFFERLENGTH; k++) {
                         for (k = 0; k < FIFOBUFFERLENGTH; k++) {
                             *response++ = FEBEX_FifoBuffer[m][k];
//                             if (++j == FIFOBUFFERLENGTH) j = 0;
                         }
                         *response++ = 0xaa5555aa;
#endif
                         break;

                       case 5:          /*  VME   */
#ifdef VMEPRESENT
                         if (VME_Sources == 0) break;

                         for (k = 0, j = VME_FifoBufferPtr; k < FIFOBUFFERLENGTH; k++) {
                             *response++ = VME_FifoBuffer[j];
                             if (++j == FIFOBUFFERLENGTH) j = 0;
                         }
                         *response++ = 0xaa5555aa;
#endif
                         break;

                       case 6:          /*  VXI 8080   */
#ifdef VXI8080PRESENT
                         if (VXI8080_FifoBufferPtr == 0) break;

                         for (k = 0, j = VXI8080_FifoBufferPtr; k < FIFOBUFFERLENGTH; k++) {
                             *response++ = VXI8080_FifoBuffer[j];
                             if (++j == FIFOBUFFERLENGTH) j = 0;
                         }
                         *response++ = 0xaa5555aa;
#endif
                         break;

                       case 7:          /*  VF48   */
#ifdef VF48PRESENT
                         if (VF48_Module[m & 3] == 0) break;

                         for (k = 0, j = VF48_FifoBufferPtr[m & 3]; k < (m >> 2); k++) {
                             if (++j == VF48FIFOBUFFERLENGTH) j = 0;
                         }

                         for (k = 0; k < 100; k++) {
                             *response++ = VF48_FifoBuffer[m & 3][j];
                             if (++j == VF48FIFOBUFFERLENGTH) j = 0;
                         }
                         *response++ = 0xaa5555aa;
#endif
                         break;

                       case 8:          /*  GRT4P   */
#ifdef GRT4PPRESENT
                         if (GRT4P_Module[m & 3] == 0) break;

                         for (k = 0, j = GRT4P_FifoBufferPtr[m & 3]; k < (m >> 2); k++) {
                             if (++j == GRT4PFIFOBUFFERLENGTH) j = 0;
                         }

                         for (k = 0; k < 100; k++) {
                             *response++ = GRT4P_FifoBuffer[m & 3][j];
                             if (++j == GRT4PFIFOBUFFERLENGTH) j = 0;
                         }
                         *response++ = 0xaa5555aa;
#endif
                         break;

                       case 9:          /*  VSSP & VSNP   */
#ifdef VsspPRESENT
                         if (Vssp_ModuleNum == 0) break;

                         for (k = 0, j = VSSP_FifoBufferPtr; k < FIFOBUFFERLENGTH; k++) {
                             *response++ = VSSP_FifoBuffer[j];
                             if (++j == FIFOBUFFERLENGTH) j = 0;
                         }
                         *response++ = 0xaa5555aa;
#endif

#ifdef VsnpPRESENT
                         if (Vsnp_ModuleNum == 0) break;

                         for (k = 0, j = VSNP_FifoBufferPtr; k < FIFOBUFFERLENGTH; k++) {
                             *response++ = VSNP_FifoBuffer[j];
                             if (++j == FIFOBUFFERLENGTH) j = 0;
                         }
                         *response++ = 0xaa5555aa;
#endif

                         break;

                       case 10:          /*  MDI2  */
#ifdef MDI2PRESENT
                         if (MDI2_Module[m] == 0) break;

                         for (k = 0, j = MDI2_FifoBufferPtr[m]; k < FIFOBUFFERLENGTH; k++) {
                             *response++ = MDI2_FifoBuffer[m][j];
                             if (++j == FIFOBUFFERLENGTH) j = 0;
                         }
                         *response++ = 0xaa5555aa;
#endif
                         break;

                       case 11:          /*  PORGAMRAYS  or PGRIS */
#ifdef PORGAMRAYSPRESENT
                         m = 1;

                         for (k = 0, j = PORGAMRAYS_FifoBufferPtr[m]; k < FIFOBUFFERLENGTH; k++) {
                             *response++ = PORGAMRAYS_FifoBuffer[m][j];
                             if (++j == FIFOBUFFERLENGTH) j = 0;
                         }
                         *response++ = 0xaa5555aa;
#endif
#ifdef PGRISPRESENT
                         m = 1;

                         for (k = 0, j = PGRIS_FifoBufferPtr[m]; k < FIFOBUFFERLENGTH; k++) {
                             *response++ = PGRIS_FifoBuffer[m][j];
                             if (++j == FIFOBUFFERLENGTH) j = 0;
                         }
                         *response++ = 0xaa5555aa;
#endif
                         break;

                       case 12:          /*  Reserved for SAGE COLLATOR  */
                       case 13:          /*  Reserved for SAGE MERGER  */
                             j = k =0;
                         break;

                       case 14:          /*  LyrTech   */
#ifdef VHSADCPRESENT
                        if (VHSADC_Handle[m] == INVALID_HANDLE_VALUE) break;

                         for (k = 0, j = VHSADC_FifoBufferPtr[m]; k < FIFOBUFFERLENGTH; k++) {
                             *response++ = VHSADC_FifoBuffer[m][j];
                             if (++j == FIFOBUFFERLENGTH) j = 0;
                         }
                         *response++ = 0xaa5555aa;
#endif
                         break;

                       case 16:          /*  User  */

                         for (k = 0, j = User_FifoBufferPtr; k < FIFOBUFFERLENGTH; k++) {
                             *response++ = User_FifoBuffer[j];
                             if (++j == FIFOBUFFERLENGTH) j = 0;
                         }
                         *response++ = 0xaa5555aa;

                         break;

                       case 17:          /*  AIDA ASIC buffer  */
                       case 18:          /*  AIDA WAVE buffer  */
/*    
      for Aida there are 2 buffers / module  we return 100 words
      m defines an offset into the Fifo buffer to start at
*/
      
#ifdef AidaPRESENT
                       if (type == 17) {i = 0;}
                       if (type == 18) {i = 1;}

                         c = 100;
                         for (k = 0, j = Aida_FifoBufferPtr[i]; k < AIDAFIFOBUFFERLENGTH; k++) {
                             if (m == 0) {*response++ = Aida_FifoBuffer[i][j]; c--;} else {m--;}
                             if (c == 0) {break;}
                             if (++j == AIDAFIFOBUFFERLENGTH) j = 0;
                         }
                         *response++ = 0xaa5555aa;
#endif
                         break;

                       case 19:          /*  R3B buffer  */
/*
    for R3B we return 100 words 
    m defines an offset into the Fifo buffer to start at
*/
      
#ifdef R3BPRESENT
                         c = 100;
                         for (k = 0, j = R3B_FifoBufferPtr; k < R3BFIFOBUFFERLENGTH; k++) {
                             if (m == 0) {*response++ = R3B_FifoBuffer[j]; c--;} else {m--;}
                             if (c == 0) {break;}
                             if (++j == R3BFIFOBUFFERLENGTH) j = 0;
                         }
                         *response++ = 0xaa5555aa;
#endif
                         break;

                       default:
                         break;
                   }
                   break;



               case 20:
                   ptr = exec_Parameter;
                   (void) transferSetUser(0);
#ifndef GANIL
                   status = transferStatus();
#else
                   if (XferMode == 5) {
                       status = GANILtransferStatus();
                   } else {
                       status = transferStatus();
                   }
#endif
                   if (XferMode == 4 && status == 0) {*dacq_TxEnable = 0;}
                   sprintf(ptr, "%d", status);
                   break;
               case 21:
                   ptr = exec_Parameter;
                   (void) transferSetUser(1);
#ifndef GANIL
                   status = transferStatus();
#else
                   if (XferMode == 5) {
                       status = GANILtransferStatus();
                   } else {
                       status = transferStatus();
                   }
#endif
                   if (XferMode == 4 && status == 0) {*dacq_Tx2Enable = 0;}
                   sprintf(ptr, "%d", status);
                   break;
               case 22:
#ifdef USEVX718
                   VX718End();
#endif
                   sprintf (message, "Terminated at your request");
                   *exec_Signal = 0;   /* clear signal */
                   *exec_Action = 0;    /* and clear Action  */
                   reportandquit();     /*   this never returns   */
                   break;
               case 23: 
                   if (currentstate != GOING) break;
                   if (PauseState != RUNNING)  break;
                   PauseState = PAUSED;
                   break;
               case 24: 
                   if (currentstate != GOING) break;
                   PauseState = RUNNING;
                   break;
               default:
                   printf("Undefined action requested SIGUSR2 (%d)\n", *exec_Action);
                   break;
           }
           *exec_Signal = 0;   /* clear signal */
           *exec_Action = 0;    /* and clear Action  */
           break;

#if defined SAGE
       case SIGALRM:

           if(*dacq_Trace > 2) printf("received SIGALRM\n");

           DACQ_alarm();
           DACQ_UpdateStats();
           break;
#endif

       case SIGINT:

//           if(*dacq_Trace == 1) printf("received SIGINT\n");

           if (!PauseState) DACQ_interrupt();
           DACQ_UpdateStats();
           if (*exec_Signal == SIGINT) *exec_Signal = 0;   /* clear signal */
           break;

       default:
           printf("Unexpected signal received (%d)\n", Signal);
           break;
    }

}
