

/*
    This is the Stats task for WIn32
*/


#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif

#include "netvar.h"
#include "histogramming.h"

#define MAXCHANNELS 0x10000

#define NUMCOUNTERS 64
#define GOING 2


/* --------------------------------------------------------------------- */

main (int argc, char **argv)
{
   int Stats[NUMCOUNTERS];
   int * StatsMem[NUMCOUNTERS];

   int Rates[NUMCOUNTERS];
   int * RatesMem[NUMCOUNTERS];

   int Counts[NUMCOUNTERS];
   int i;
   int *delay;
   unsigned long *Statmemaddr;
   unsigned long *Ratememaddr;
   unsigned int Statmemlen, Ratememlen;
   int *dacq_State;
   unsigned int Rate[MAXCHANNELS+1];
   unsigned int Count[MAXCHANNELS+1];
   unsigned int Stat[MAXCHANNELS+1];


//    initialise Stats Rates NetVar arrays

   for(i=0;i<NUMCOUNTERS;i++) {
       Counts[i]=Rates[i]=0;
       StatsMem[i] = (int *)getNetIntArrayMem("DACQ_Stats",i);
       RatesMem[i] = (int *)getNetIntArrayMem("DACQ_Rates",i);
   }

   dacq_State = (int *)getNetIntMem("DACQ_State");   /* data acquisition state */
   delay = (int *)getNetIntMem("DACQ_StatsTime");
   
//    initialise the Stat and Rate histograms used for detector rates

   Statmemaddr=Ratememaddr=NULL;
   Statmemlen=Ratememlen=0;
   
   for(i=0;i<=MAXCHANNELS;i++) {Count[i]=Rate[i]=0;}

  for (;;)
  {

/*
     if (Statmemaddr != NULL)
         (void) sasReleaseSpecMem("Stat", (unsigned char *)Statmemaddr);
     Statmemaddr=NULL;
     Statmemlen=0;
*/

     if (Ratememaddr != NULL)
         (void) sasReleaseSpecMem("Rate", (unsigned char *)Ratememaddr);
     Ratememaddr=NULL;
     Ratememlen=0;

     Sleep((*delay)*1000);

     if (*dacq_State != GOING) {
         for(i=0;i<NUMCOUNTERS;i++) {*RatesMem[i] = 0;}
         continue;
     }

     if (Statmemaddr == NULL)
         Statmemaddr = (unsigned long *) sasGetSpecMem("Stat");
     if (Statmemaddr != NULL)
         Statmemlen  = (unsigned int) (sasGetSpecLen("Stat") >> 2);
     
     if (Ratememaddr == NULL)
         Ratememaddr = (unsigned long *) sasGetSpecMem("Rate");
     if (Ratememaddr != NULL)
         Ratememlen  = (unsigned int) (sasGetSpecLen("Rate") >> 2);
    
     if (Statmemlen != Ratememlen) {continue;}

/*    Note for Win32 this is a separate task and so we have to task current Stats values
      from the netvar  */

//     update from the netvars arrays 
     for(i=0;i<NUMCOUNTERS;i++) {Stats[i] = *StatsMem[i];}
     
     if (Statmemaddr != NULL) {
         for(i=0;i<(int)Statmemlen;i++) {Stat[i] = Statmemaddr[i];}  // current counters
     }

//    update rates
     for(i=0;i<NUMCOUNTERS;i++) {Rates[i]=(Stats[i]-Counts[i])/(*delay); Counts[i]=Stats[i];}
     
     if (Ratememaddr != NULL) {
         for(i=0;i<(int)Statmemlen;i++)  {Rate[i]=(Stat[i]-Count[i])/(*delay); Count[i]=Stat[i];}
     }

//    and update the netvars arrays
     for(i=0;i<NUMCOUNTERS;i++) {*RatesMem[i] = Rates[i];}
     
     if (Ratememaddr != NULL) {
         for(i=0;i<(int)Ratememlen;i++) {Ratememaddr[i] = Rate[i];}
     }
  }
}

/* --------------------------------------------------------------------- */
