
#include "WIN32signals.h"



void cond_wait_for_signal ()
{
   DWORD dwEvent;

   if (signal_occurred == 0)
   {

      dwEvent = WaitForMultipleObjects(
        3,           // number of objects
        SigEvent,    // array of objects
        FALSE,       // wait for any
        1);          // 1 millisec wait

      if (dwEvent == WAIT_TIMEOUT) {Signal = 0; return;}   /*   no Signal  */

      switch (dwEvent)
      {
        case WAIT_OBJECT_0 + SIGINT - 1:
             signal_occurred++;
             Signal = SIGINT;
//             printf("received signal SIGINT\n");
             break;
        case WAIT_OBJECT_0 + SIGUSR1 - 1:
             signal_occurred++;
             Signal = SIGUSR1;
//             printf("received signal SIGUSR1\n");
             break;
        case WAIT_OBJECT_0 + SIGUSR2 - 1:
             signal_occurred++;
             Signal = SIGUSR2;
//             printf("received signal SIGUSR2\n");
             break;
        default:
             ReportErrorMsg("wait error");
             Signal = 0;
      }
   }

   if (signal_occurred == 0)
   {
      Signal = 0; return;   /*   no Signal  */
   }

   signal_occurred--;

   return;
}

void signal_setup ()
{
    char EventName[16];
    char msgBuf[BUF_SIZE];
    DWORD dwChars;

    sprintf(msgBuf, "Creating Signal Events\n");
    WriteConsole(hStdout, msgBuf, strlen(msgBuf), &dwChars, NULL);

    sprintf(EventName, "Sig%d_INT", mypid);
    SigEvent[SIGINT-1] = CreateEvent(NULL, FALSE, FALSE, EventName);
    if (SigEvent[SIGINT-1] == NULL) {
        ReportErrorMsg("Creating event SigINT");
    }

    sprintf(EventName, "Sig%d_USR1", mypid);
    SigEvent[SIGUSR1-1] = CreateEvent(NULL, FALSE, FALSE, EventName);
    if (SigEvent[SIGUSR1-1] == NULL) {
        ReportErrorMsg("Creating event SigUSR1");
    }

    sprintf(EventName, "Sig%d_USR2", mypid);
    SigEvent[SIGUSR2-1] = CreateEvent(NULL, FALSE, FALSE, EventName);
    if (SigEvent[SIGUSR2-1] == NULL) {
        ReportErrorMsg("Creating event SigUSR2");
    }

    if (SigEvent[SIGINT-1] == NULL || SigEvent[SIGUSR1-1] == NULL || SigEvent[SIGUSR2-1] == NULL) {
         sprintf(msgBuf,"Finished with errors\n");
    } else {
         sprintf(msgBuf,"Done\n");
    }

       WriteConsole(hStdout, msgBuf, strlen(msgBuf), &dwChars, NULL);

}

void signal_block() {};

void sigint_received (int signo)
{
    signal_occurred++;
    Signal = signo;
}

