
#ifndef _BUFFERS_H
#define _BUFFERS_H

//    buffers are defined as unsigned short for FERA and unsigned int for VXI and Megha

#ifndef MAXBUFFERSIZE 
#define MAXBUFFERSIZE 128 *1024       /*  default maximum output buffer is 128 Kbytes for 64K * 16 bit data  */
#endif

#ifndef USERBUFFERSIZE
#define USERBUFFERSIZE 1024
#endif

int Output_BufferSize;              /*  in units of bytes  */
int Output_Buffer_Length;           /*  maximum length for data block (bytes)  */
int Buffer_Offset;                  /*  of start of event data (bytes) (0 or 32)  */



#ifndef NUMOUTPUTBUFFERS
#define NUMOUTPUTBUFFERS NUMOVERLAPS*NUMTHREADS*NUMDATASTREAMS
#endif

int CurrentOutputBufferNum = 0;

#ifdef USESHORT
unsigned short OutputBuffer[NUMOUTPUTBUFFERS][MAXBUFFERSIZE/2];
#ifdef USETHREADS
int OutputBufferLen[NUMOUTPUTBUFFERS];
unsigned short * CurrentOutputBuffer[NUMOUTPUTBUFFERS];
#else
int OutputBufferLen[NUMDATASTREAMS]            ;             /*  units of short  */
unsigned short * CurrentOutputBuffer[NUMDATASTREAMS];
#endif
unsigned short * OutputBufferAddr[NUMOUTPUTBUFFERS];
#endif

#ifdef USEINT
unsigned int OutputBuffer[NUMOUTPUTBUFFERS][MAXBUFFERSIZE/4];
#ifdef USETHREADS
int OutputBufferLen[NUMOUTPUTBUFFERS];
unsigned int * CurrentOutputBuffer[NUMOUTPUTBUFFERS];
#else
int OutputBufferLen[NUMDATASTREAMS];             /*  units of int  */
unsigned int * CurrentOutputBuffer[NUMDATASTREAMS];
#endif
unsigned int * OutputBufferAddr[NUMOUTPUTBUFFERS];
#endif

#ifndef NUMEVENTBUFFERS
#ifdef D2VB
#define NUMEVENTBUFFERS 4
#else
#define NUMEVENTBUFFERS 1
#endif
#endif
int CurrentEventBufferNum = 0;

#ifdef USESHORT
unsigned short EventBuffer[NUMEVENTBUFFERS][MAXBUFFERSIZE/2];
#ifdef USETHREADS
int EventBufferLen[NUMEVENTBUFFERS];
#else
int EventBufferLen =0;              /*  units of short   */
#endif
unsigned short * EventBufferAddr = &EventBuffer[0][0];
unsigned short * eventbuffer;    /*  pointer into the buffer  */
unsigned int * EventBufferAddrL = (unsigned int *) &EventBuffer[0][0];
unsigned int * eventbufferL;    /*  pointer into the buffer  */
unsigned short * itembuffer;
unsigned short UserEventBuffer[USERBUFFERSIZE/2];
int UserEventBufferlen = 0;
unsigned short * UserEventBufferAddr = &UserEventBuffer[0];
#endif

#ifdef USEINT
unsigned int EventBuffer[NUMEVENTBUFFERS][MAXBUFFERSIZE/4];
#ifdef USETHREADS
int  EventBufferLen[NUMEVENTBUFFERS];
#else
int EventBufferLen =0;              /*  units of int   */
#endif
unsigned int * EventBufferAddr = &EventBuffer[0][0];
unsigned int * eventbuffer;    /*  pointer into the buffer  */
unsigned int * itembuffer;
unsigned int UserEventBuffer[USERBUFFERSIZE/4];
int UserEventBufferlen = 0;
unsigned int * UserEventBufferAddr = &UserEventBuffer[0];
#endif

#ifdef USEINT
unsigned int * DACQ_InputBuffer;       /*   used for DMA of data blocks from DACQ data RAM   */
unsigned int * DACQ_Kernel_InputBuffer;       /*   used for DMA of data blocks from DACQ data RAM   */
int DACQ_BufferSize = 0;               /*  in units of bytes  */
int DACQ_InputBufferLen =0;            /*   units of int  */
#endif

#ifdef USESHORT
unsigned short * DACQ_InputBuffer;     /*   used for DMA of data blocks from DACQ data RAM   */
unsigned short * DACQ_Kernel_InputBuffer;     /*   used for DMA of data blocks from DACQ data RAM   */
int DACQ_BufferSize = 0;               /*  in units of bytes  */
int DACQ_InputBufferLen =0;            /*   units of short  */
#endif
 
int DACQ_State = 0;
int PauseState = 0;

unsigned int EventNumber = 0;
unsigned short EventNumberMSW = 0, EventNumberLSW = 0;
unsigned short EventTagH = 0, EventTagM = 0, EventTagL = 0;

long TestBuffer[250];    /* for the test mode with the x2vb module  */
int TestBufferIndex=0;

char RawDataStorage[80];

#ifndef WIN32
FILE * RawFilehandle =0;     /* used for writing RAW data  */
#else
HANDLE RawFilehandle =0;
#endif

#endif
