

/*
    This code insert is the Heartbeat thread
*/

#ifndef WIN32
#include <pthread.h>
#endif

#ifdef LYNXOS
#include <time.h>
#include <resource.h>
#else
#ifdef WIN32
#else
#include <unistd.h>
#endif
#endif


/* --------------------------------------------------------------------- */

#ifndef WIN32
void *DACQ_HeartBeat(void * arg)
#else
DWORD WINAPI DACQ_HeartBeat(LPVOID arg)
#endif
{
   int PushEnable;
   int DelayTime;
   int ntxbuffers;
   int ntx2buffers;
   int enable0, enable1;
   int i;

#ifdef LYNXOS
   int id, prty1, prty2;
#endif

      printf("Heartbeat thread starting\n");

    signal_block();       /*    mask off signals handled by the main thread   */

//   adjust priority - run just above main data acquisition program

#ifdef LYNXOS
          id = BUILDPID(getpid(), getstid());
          prty1 = getpriority(PRIO_PROCESS, id);
          (void) setpriority(PRIO_PROCESS, id, prty1 + 2);
          prty2 = getpriority(PRIO_PROCESS, id);
          printf("Heatbeat thread priority changed from %d to %d\n", prty1, prty2);
#else
#ifdef WIN32
    if (!SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_HIGHEST))  ErrorHandler(TEXT("SetThreadPriority"));
#else
     nice(-2);
#endif
#endif

    xfer_pushRequired = 0;

   
  for (;;)
  {

     ntxbuffers = Stats[TXBUFFERS];
     ntx2buffers = Stats[TX2BUFFERS];

   readNetInt("DACQ_PushEnable", 0, 1, &PushEnable);
   DelayTime = PushEnable;
   if (DelayTime <= 0) DelayTime = 60;    /* 1 sec */

   readNetInt("DACQ_TxEnable", 0, 1, &enable0);
   readNetInt("DACQ_Tx2Enable", 0, 1, &enable1);

#ifdef LYNXOS
     taskDelay(DelayTime);
#else
#ifdef WIN32
     Sleep(DelayTime*(1000/60));
#else
     usleep (DelayTime*(1000000/60));
#endif
#endif

     if (PushEnable > 0)  {

         if (enable0 == 1 && Stats[TXBUFFERS] == ntxbuffers) {

/*    nothing has been sent since the last check - do a push   */
/*    for Polling DA programs just inform them  */

             if (*dacq_PollTicks > 32) {xfer_pushRequired = 1;} else {xfer_push(0);}
         }

         if (enable1 == 1 && Stats[TX2BUFFERS] == ntx2buffers) {

/*    nothing has been sent since the last check - do a push   */
/*    for Polling DA programs just inform them  */

             if (*dacq_PollTicks > 32) {xfer_pushRequired = 1;} else {xfer_push(1);}
         }
     }

#ifdef USETHREADS
           DACQ_UpdateStats();
#endif

  }

   exit(0);
}

/* --------------------------------------------------------------------- */

void DACQ_InitHeartBeat()
{

#ifndef WIN32
   pthread_t ThreadID;
   pthread_attr_t ThreadAttr;
   int err;

/*    create a thread for the heart beat thread  */

       (void) pthread_attr_init(&ThreadAttr);
       (void) pthread_attr_setdetachstate(&ThreadAttr,PTHREAD_CREATE_DETACHED);
       
       err = pthread_create(&ThreadID, &ThreadAttr, DACQ_HeartBeat, NULL);
       if (err != 0) {
           perror("Error in pthread_create:");
           printf("Failed to start heartbeat thread: This must be fixed\n");
           exit(16);
       }

      printf("Heartbeat thread created\n");

#else

         hThreadArray[HEARTBEAT] = CreateThread(
              NULL,                         // default security attributes
              0,                            // use default stack size
              DACQ_HeartBeat,                   // thread function name
              NULL,                         // argument to thread function
              0,                            // use default creation flags
              &dwThreadIdArray[HEARTBEAT]);                        // returns the thread identifier

         if (hThreadArray[HEARTBEAT] == NULL) {
             ErrorHandler(TEXT("CreateThread for Heartbeat"));
             ExitProcess(1);
         }

      sprintf(msgBuf, "Heartbeat thread created\n");
    WriteConsole(hStdout, msgBuf, strlen(msgBuf), &dwChars, NULL);

         ThreadInUse[HEARTBEAT] = 1;
         NumThreads++;

#endif

    return;
}

/* --------------------------------------------------------------------- */

