
/*

     code insert to provide standard netvars and options
     we read all NetVars which will cause any which do not exist to be created (with value 0)
     
*/

#ifndef MAXCOUNTERS
#define MAXCOUNTERS NUMCOUNTERS
#endif

   printf ("Creating NetVars\n");

   assignNetInt("PID_EXEC", 0, 1, mypid);

   readNetString("EXEC_ID", 0, 1, ScratchNetString);
   EXEC_ID = (char *)getNetStringMem("EXEC_ID");
   strcpy (EXEC_ID, &ID[0]);

/*    obtain pointers to the NetVars   */

   readNetInt("EXEC_Action", 0, 1, &ScratchNetInt);
   exec_Action     = (int *)getNetIntMem("EXEC_Action");
   *exec_Action = 0;

   readNetInt("EXEC_Signal", 0, 1, &ScratchNetInt);
   exec_Signal     = (int *)getNetIntMem("EXEC_Signal");
   *exec_Signal = 0;
   
   readNetString("EXEC_Parameter", 0, 1, ScratchNetString);
   exec_Parameter  = (char *)getNetStringMem("EXEC_Parameter");

   assignNetBlock("EXEC_Response", 0, NETBLOCKLENGTH, 0);
   exec_Response  = (char *)getNetBlockMem("EXEC_Response");

/*    program options  */

   readNetInt("DACQ_TxInit", 0, 1, &ScratchNetInt);   /* this will create netint if it does not exist */
   dacq_TxInit   = (int *)getNetIntMem("DACQ_TxInit");  /* =0 default attempt to connect on program startup;  =1 delay until command received */

   readNetString("TS_Server", 0 , 1, TS_Server);
   readNetInt("TS_Port", 0 , 1, &TS_Port);

   readNetString("TS2_Server", 0 , 1, TS2_Server);
   readNetInt("TS2_Port", 0 , 1, &TS2_Port);

   readNetInt("DACQ_TxEnable", 0, 1, &ScratchNetInt);   /* this will create netint if it does not exist */
   dacq_TxEnable   = (int *)getNetIntMem("DACQ_TxEnable");

   readNetInt("DACQ_Tx2Enable", 0, 1, &ScratchNetInt);   /* this will create netint if it does not exist */
   dacq_Tx2Enable   = (int *)getNetIntMem("DACQ_Tx2Enable");

   readNetInt("DACQ_IgnoreNullEvents", 0, 1, &ScratchNetInt); /* this will create netint if it does not exist */
   dacq_IgnoreNullEvents   = (int *)getNetIntMem("DACQ_IgnoreNullEvents");
   
   readNetInt("DACQ_HistEnable", 0, 1, &ScratchNetInt);
   dacq_HistEnable = (int *)getNetIntMem("DACQ_HistEnable");

   readNetInt("DACQ_HistMode", 0, 1, &ScratchNetInt);
   dacq_HistMode = (int *)getNetIntMem("DACQ_HistMode");
   
   assignNetInt("DACQ_SpectraMapped", 0, 1, 0);
   dacq_SpectraMapped = (int *)getNetIntMem("DACQ_SpectraMapped");
   
   readNetInt("DACQ_Trace", 0, 1, &ScratchNetInt);
   dacq_Trace      = (int *)getNetIntMem("DACQ_Trace");
   
   readNetInt("DACQ_UseGroup", 0, 1, &dacq_UseGroup);
   readNetInt("DACQ_UseReadOutThreads", 0, 1, &dacq_UseReadOutThreads); /* read to ensure created */

   readNetInt("DACQ_RawMode", 0, 1, &ScratchNetInt);
   dacq_RawMode = (int *)getNetIntMem("DACQ_RawMode");
   
   readNetInt("DACQ_RdOutEnable", 0, 1, &ScratchNetInt);
   dacq_RdOutEnable   = (int *)getNetIntMem("DACQ_RdOutEnable");

   readNetInt("Output_BufferSize", 0, 1, &Output_BufferSize);
   if (Output_BufferSize == 0) {
       Output_BufferSize = MAXBUFFERSIZE & 0xfffffc00;  /* round down to 1Kbyte units */
   } else {
       if (Output_BufferSize <= 1024) {Output_BufferSize = Output_BufferSize * 1024;}
   }

   readNetInt("Format_Option", 0, 1, &Format_Option);
   if (Format_Option == 0) {
       Format_Option = FORMAT_OPTION;
   }

   readNetInt("Xfer_Option", 0, 1, &Xfer_Option);
   if (Xfer_Option == 0) {
       Xfer_Option = XFER_OPTION;
   }

   switch (Xfer_Option) {
       case 3:                         /*  MIDAS */
          Buffer_Offset = 32;          /*  allow for 32 byte protocol header on TCP connection  */
          XferMode=3;
          break;
       case 4:                         /*  GSI MBS for RISING  */
          Buffer_Offset = 0;
          XferMode=4;
          break;
       case 5:
          Buffer_Offset = 32;      /*   for GANIL & MIDAS  */
          Output_BufferSize = 16*1024;
          XferMode =5;
          break;
       case 6:
          Buffer_Offset = 32;      /*   for LNL & MIDAS  */
          XferMode =6;
          break;
       case 1:                         /*  MIDAS */
       default:
          Buffer_Offset = 32;          /*  allow for 32 byte protocol header on TCP connection  */
          XferMode=1;
          break;
   }

    EBXferMode = XferMode;       /*  no longer used   */

/*    only allow EBXfer_Option to have value compatible with Xfer_Option  */

/*
   readNetInt("EBXfer_Option", 0, 1, &ScratchNetInt);
   if (XferMode == 1 && ScratchNetInt == 3) EBXferMode = ScratchNetInt;
   if (XferMode == 3 && ScratchNetInt == 1) EBXferMode = ScratchNetInt;
   if (XferMode == 5 && ScratchNetInt == 3) EBXferMode = ScratchNetInt;
   if (XferMode == 5 && ScratchNetInt == 5) EBXferMode = ScratchNetInt;
   if (XferMode == 6 && ScratchNetInt == 6) EBXferMode = ScratchNetInt;
   if (XferMode == 3 && ScratchNetInt == 5) EBXferMode = ScratchNetInt;
*/

   Output_Buffer_Length = Output_BufferSize - Buffer_Offset;

#ifdef USESHORT
   for (i=0; i<NUMOVERLAPS*NUMTHREADS*NUMDATASTREAMS; i++) {
       OutputBufferAddr[i] = &OutputBuffer[i][Buffer_Offset >> 1];
   }
#endif

#ifdef USEINT
   for (i=0; i<NUMOVERLAPS*NUMTHREADS*NUMDATASTREAMS; i++) {
       OutputBufferAddr[i] = &OutputBuffer[i][Buffer_Offset >> 2];
   }
#endif

   CurrentOutputBufferNum = 0;

#ifdef USETHREADS
#else
   for (i=0; i<NUMDATASTREAMS; i++) {
      CurrentOutputBuffer[i] =  OutputBufferAddr[i*(NUMOVERLAPS*NUMTHREADS)];
   }
#endif

   CurrentEventBufferNum = 0;
   EventBufferAddr = &EventBuffer[0][0];

   printf ("Output buffer length = %d; format option = %d; transfer option = %d\n", Output_Buffer_Length, Format_Option, XferMode);
   printf ("EB transfer option = %d\n", EBXferMode);

   assignNetInt("Format_Option", 0, 1, Format_Option);
   assignNetInt("Xfer_Option", 0, 1, Xfer_Option);
//   assignNetInt("EBXfer_Option", 0, 1, EBXfer_Option);

/*    basic control and monitoring  */
   readNetInt("DACQ_Alive", 0, 1, &ScratchNetInt);
   dacq_Alive      = (int *)getNetIntMem("DACQ_Alive");
   (*dacq_Alive)++;
   
   readNetInt("DACQ_State", 0, 1, &ScratchNetInt);
   dacq_State = (int *)getNetIntMem("DACQ_State");
   *dacq_State =  0;
   
/*    test mode control and options   */
   readNetInt("DACQ_TestMode", 0, 1, &ScratchNetInt);   /* read to ensure created */
   dacq_TestMode = (int *)getNetIntMem("DACQ_TestMode");

   readNetInt("DACQ_DebugMode1", 0, 1, &ScratchNetInt);   /* read to ensure created */
   dacq_DebugMode1 = (int *)getNetIntMem("DACQ_DebugMode1");

   readNetInt("DACQ_DebugMode2", 0, 1, &ScratchNetInt);   /* read to ensure created */
   dacq_DebugMode2 = (int *)getNetIntMem("DACQ_DebugMode2");

   readNetInt("DACQ_DebugMode3", 0, 1, &ScratchNetInt);   /* read to ensure created */
   dacq_DebugMode3 = (int *)getNetIntMem("DACQ_DebugMode3");

   readNetInt("DACQ_DebugMode4", 0, 1, &ScratchNetInt);   /* read to ensure created */
   dacq_DebugMode4 = (int *)getNetIntMem("DACQ_DebugMode4");

   readNetInt("DACQ_ReadOutOption", 0, 1, &ScratchNetInt);   /* read to ensure created */
   dacq_ReadOutOption = (int *)getNetIntMem("DACQ_ReadOutOption");

   readNetInt("DACQ_MultFactor", 0, 1, &ScratchNetInt);   /* read to ensure created */
   if (ScratchNetInt == 0) {assignNetInt("DACQ_MultFactor", 0, 1, 1);}  /*  default value is 1  */
   dacq_MultFactor   = (int *)getNetIntMem("DACQ_MultFactor");
     
   readNetInt("DACQ_DelayTicks", 0, 1, &ScratchNetInt);
   if (ScratchNetInt == 0) {assignNetInt("DACQ_DelayTicks", 0, 1, DELAYTICKS);}
   dacq_DelayTicks   = (int *)getNetIntMem("DACQ_DelayTicks");

   readNetInt("DACQ_PollTicks", 0, 1, &ScratchNetInt);
   if (ScratchNetInt == 0) {assignNetInt("DACQ_PollTicks", 0, 1, POLLTICKS);}
   dacq_PollTicks   = (int *)getNetIntMem("DACQ_PollTicks");

/*    other options   */

   readNetInt("DACQ_PushEnable", 0, 1, &PushEnable);
   readNetInt("DACQ_FlushEnable", 0, 1, &FlushEnable);
   readNetInt("Xfer_Priority", 0, 1, &Xfer_Priority);
   readNetInt("Xfer_Overlap", 0, 1, &Xfer_Overlap);
   readNetInt("Xfer_BlockMode", 0, 1, &Xfer_BlockMode);

/*    lastly statistics array  */

   numcounters = NUMCOUNTERS;
   maxcounters = MAXCOUNTERS;

   readNetInt("DACQ_StatsTime", 0, 1, &ScratchNetInt);
   if (ScratchNetInt == 0) {assignNetInt("DACQ_StatsTime", 0, 1, 1);}  /* default 1 sec */

   if (numcounters == maxcounters) {
       readNetInt("DACQ_Stats", 0, 1, &ScratchNetInt);               /*  this will also create it */
       for(i=0;i<numcounters;i++) {
           Stats[i] = 0;
           StatsMem[i] = (int *)getNetIntArrayMem("DACQ_Stats",i);
           *StatsMem[i] = 0;
       }
   } else {
       readNetInt("DACQ_Stats", 0, 1, &ScratchNetInt); 
       for (i=1; i<(numcounters/maxcounters); i++) {
          sprintf(message,"DACQ_Stats%d",i);
          readNetInt(message, 0, 1, &ScratchNetInt);
       }
       for(i=0;i<numcounters;i++) {
           Stats[i] = 0;
           if (i < maxcounters) {
               StatsMem[i] = (int *)getNetIntArrayMem("DACQ_Stats",i);
           } else {
               j = i-((i/maxcounters)*maxcounters);
               sprintf(message,"DACQ_Stats%d",(i/maxcounters));
               StatsMem[i] = (int *)getNetIntArrayMem(message,j);
           }
           *StatsMem[i] = 0;
       }
   }

   printf ("NetVars created and initialised\n");


