#include "report.h"

#ifdef LYNXOS
#include <time.h>
#include <resource.h>
#else
#ifdef WIN32
#else
#include <unistd.h>
#endif
#endif

/* --------------------------------------------------------------------- */
#ifdef WIN32
void report()
{
  DWORD buflen=160;

  size_t cchStringSize;
  DWORD dwChars;

       StringCchLength(message, buflen, &cchStringSize);
       WriteConsole(hStdout, message, (DWORD)cchStringSize, &dwChars, NULL);

       msgDefineMessage (0, MSG_C_EB, MSG_S_ERROR, NULL, message);
}
#else
void report()
{
       printf ("%s\n", message);
       msgDefineMessage (0, MSG_C_EB, MSG_S_ERROR, NULL, message);
}
#endif

/* --------------------------------------------------------------------- */


void reportandquit()
{
    int delay = 2;

       printf ("%s\n", message);
       msgDefineMessage (0, MSG_C_EB, MSG_S_ERROR, NULL, message);

       sprintf(message, "%s Data Acquisition will now terminate", VERSION);
       printf ("%s\n", message);
       msgDefineMessage (0, MSG_C_EB, MSG_S_ERROR, NULL, message);

       assignNetInt("PID_EXEC", 0, 1, 0);   /* we have gone   */

#ifdef LYNXOS
     taskDelay((delay)*60);   /*  delay units are seconds */
#else
#ifdef WIN32
     Sleep((delay)*1000);
#else
     usleep ((delay)*1000000);
#endif
#endif

       exit(16);
}

/* --------------------------------------------------------------------- */

#ifdef WIN32
void ReportError () {

  LPVOID lpMsgBuf;
  DWORD ErrNo;
  DWORD buflen=160;

  size_t cchStringSize;
  DWORD dwChars;
  
       ErrNo = GetLastError();
       FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
                      NULL,
                      ErrNo,
                      0,
                      (LPTSTR) &lpMsgBuf,
                      0,
                      NULL
                      );
                      
       StringCchPrintf(message, buflen, TEXT("Error %d: %s\n"), ErrNo, lpMsgBuf);
       report();
}
#else
void ReportError () {
    sprintf(message,"Error %d - %s", errno, strerror(errno));
    report();
}
#endif

/* --------------------------------------------------------------------- */

#ifdef WIN32
void ReportErrorMsg (char *s) {

  LPVOID lpMsgBuf;
  DWORD ErrNo;
  DWORD buflen=160;

  size_t cchStringSize;
  DWORD dwChars;

       ErrNo = GetLastError();
       FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
                      NULL,
                      ErrNo,
                      0,
                      (LPTSTR) &lpMsgBuf,
                      0,
                      NULL
                      );
                      
       StringCchPrintf(message, buflen, TEXT("%s failed with error %d: %s\n"), s, ErrNo, lpMsgBuf);
       report();
}
#else
void ReportErrorMsg (char *s) {
    sprintf(message,"%s - %s", s, strerror(errno));
    report();
}
#endif

/* --------------------------------------------------------------------- */

#ifdef WIN32

#define BUF_SIZE 255

void ErrorHandler (LPTSTR lpszFunction) {

  LPVOID lpMsgBuf;
  DWORD ErrNo;

  TCHAR msgBuf[BUF_SIZE];
  size_t cchStringSize;
  DWORD dwChars;

       ErrNo = GetLastError();
       FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
                      NULL,
                      ErrNo,
                      0,
                      (LPTSTR) &lpMsgBuf,
                      0,
                      NULL
                      );
                      
       StringCchPrintf(msgBuf, BUF_SIZE, TEXT("%s failed with error %d: %s\n"), lpszFunction, ErrNo, lpMsgBuf);
       StringCchLength(msgBuf, BUF_SIZE, &cchStringSize);
       WriteConsole(hStdout, msgBuf, (DWORD)cchStringSize, &dwChars, NULL);

       LocalFree (lpMsgBuf);
}

#endif

/* --------------------------------------------------------------------- */
