

/*

     code insert to provide SIGBUS and SIGSEGV handling
     
*/

#ifndef WIN32

void sigbus_received (int signo)
{
    longjmp (jmpEnv, 1);
}

void sigsegv_received (int signo)
{
    longjmp (jmpEnv, 2);
}

void sigpipe_received (int signo)
{
    longjmp (jmpEnv, 3);
}

void sigxxx_received (int signo)
{
    sprintf(message, "Received signal %d - ignored", signo);
    report();
    longjmp (jmpEnv, 4);
}


void sigtrapandquit (char * reason) {

   switch (setjmp(jmpEnv)) {
      case 0:
         return;
      case 1:
         sprintf (message, "SIGBUS ERROR - %s", reason);
         break;
      case 2:
         sprintf (message, "SIGSEGV ERROR - %s", reason);
         break;
      case 3:
         sprintf (message, "SIGPIPE ERROR - %s", reason);
         break;
      default:
         sprintf (message, "SIGXXX ERROR - %s", reason);
         break;
   }

   reportandquit();
}

void sigtrap (char * reason) {

   switch (setjmp(jmpEnv)) {
      case 0:
         return;
      case 1:
         sprintf (message, "SIGBUS ERROR - %s: location=%d\n%s", reason, Location, sigtrapreason);
         sigbuscounter++;
         if (sigbuscounter < SIGBUSLIMIT) break;
         report();
         sprintf (message, "too many errors are occurring - pausing");
         if (sigbuscounter+sigsegvcounter < TRAPLIMIT) break;
         report();
         sprintf (message, "too many errors are occurring; you must find and fix the cause - exiting");
         reportandquit();
      case 2:
         sprintf (message, "SIGSEGV ERROR - %s: location=%d %d\n%s", reason, Location, EventBufferLen, sigtrapreason);
         sigsegvcounter++;
         if (sigsegvcounter < SIGSEGVLIMIT) break;
         report();
         sprintf (message, "too many errors are occurring - pausing");
         if (sigbuscounter+sigsegvcounter < TRAPLIMIT) break;
         report();
         sprintf (message, "too many errors are occurring; you must find and fix the cause - exiting");
         reportandquit();
      case 3:
         sprintf (message, "SIGPIPE ERROR - %s: location=%d\n%s", reason, Location, sigtrapreason);
         sigpipecounter++;
         if (sigpipecounter < SIGPIPELIMIT) break;
         report();
         sprintf (message, "too many errors are occurring - pausing");
         break;
      default:
         sprintf(message, "SIGXXX ERROR");
         break;
   }

   report();
}

void sigtrapset (char * reason) {

    strcpy(sigtrapreason, reason);

}


#else
void sigtrapandquit (char * reason) {}
void sigsegv_received (int signo) {}
void sigbus_received (int signo) {}
void sigpipe_received (int signo) {}
void sigtrap (char * reason) {}
void sigtrapset (char * reason) {}
#endif
