
#ifndef WIN32

/*    fork to create the permanent data readout task  */

   i = fork();
   if (i == 0) {
#endif

/*    start statistics threads   */

       DACQ_InitStats();

#ifndef EXCSTATHIST
       DACQ_InitStatHist();
#endif

#ifdef INCHITHIST
       DACQ_InitHitHist();
#endif

/*    start heartbeat thread   */

       DACQ_InitHeartBeat();
       
/*    enter data acquisition loop   */

//   adjust priority - run below other components

#ifdef LYNXOS
{
   int id, prty1, prty2;
          id = BUILDPID(getpid(), getstid());
          prty1 = getpriority(PRIO_PROCESS, id);
          (void) setpriority(PRIO_PROCESS, id, prty1 - 1);
          prty2 = getpriority(PRIO_PROCESS, id);
          printf("Data Acquisition thread priority changed from %d to %d\n", prty1, prty2);
}
#else
#ifdef WIN32
    if (!SetPriorityClass(GetCurrentProcess(), BELOW_NORMAL_PRIORITY_CLASS))  ErrorHandler(TEXT("SetPriorityClass"));
#else
     nice(+1);
#endif
#endif

       DACQ_exec();     /* child process executes X2VB_exec  */
       exit(16);        /*  in pratice DACQ_exec does not return */

#ifndef WIN32
   } 
   if (i < 0)  {
        perror("Error in fork:");
        printf ("Failed to start data acquisition tasks: This must be fixed\n");
        exit(16);
   }
   printf ("Data Acquisition task has PID %d\n", i);
#endif


