
/*
    This code insert formats and puts the current event into the output buffer 
    The format is determined by the global variable  Format_Option 
*/




/* --------------------------------------------------------------------- */

#ifdef USETHREADS
void xfer_RAW_event(int ID, int datastream)
#else
void xfer_RAW_event(int datastream)
#endif
{

#ifdef USEINT
   unsigned int *ptr1, *ptr2;
#endif

#ifdef USESHORT
   unsigned short *ptr1, *ptr2;
#endif

   int len;

#ifdef USETHREADS
   if (EventBufferLen[ID] == 0)  {   /* ignore event with no data */
#else
   if (EventBufferLen == 0)  {   /* ignore event with no data */
#endif
       Stats[NULLEVENTS]++;
       return;
   }

//   check that the event will fit into the output buffer
//   allow for possible 0xffffffff end of block tokens

#ifdef USESHORT
#ifdef USETHREADS
  if (((OutputBufferLen[ID] + EventBufferLen[ID] + 4) << 1) >= Output_Buffer_Length)
#else
  if (((OutputBufferLen[datastream] + EventBufferLen + 4) << 1) >= Output_Buffer_Length)
#endif
#endif

#ifdef USEINT
#ifdef USETHREADS
  if (((OutputBufferLen[ID] + EventBufferLen[ID] + 2) << 2) >= Output_Buffer_Length)
#else
  if (((OutputBufferLen[datastream] + EventBufferLen + 2) << 2) >= Output_Buffer_Length)
#endif
#endif

   {

/*    output buffer full   */

#ifdef USETHREADS
      xfer_block(ID);
#else
      xfer_block(datastream);
#endif
   }

#ifdef USETHREADS
   ptr1 = &CurrentOutputBuffer[ID][OutputBufferLen[ID]];
#else
   ptr1 = &CurrentOutputBuffer[datastream][OutputBufferLen[datastream]];
#endif

/*    copy current event into the output buffer   */

#ifdef USETHREADS
   ptr2 = &EventBuffer[ID][0];
   len = EventBufferLen[ID];
#else
   ptr2 = EventBufferAddr;
   len = EventBufferLen;
#endif

   if (len > 0) {
       while (len--) {*ptr1++ = *ptr2++;}
   }

#ifdef USETHREADS
   OutputBufferLen[ID] += EventBufferLen[ID];
#else
   OutputBufferLen[datastream] += EventBufferLen;
#endif
}

/* --------------------------------------------------------------------- */

#ifdef USETHREADS
void xfer_EUROGAM_event(int ID)
#else
void xfer_EUROGAM_event()
#endif
{
   int len; 

#ifdef USEINT
   unsigned int *ptr1, *ptr2;
#endif

#ifdef USESHORT
   unsigned short *ptr1, *ptr2;
#endif

#ifdef USETHREADS
   if (EventBufferLen[ID] == 0)  {   /* ignore event with no data */
#else
   if (EventBufferLen == 0)  {   /* ignore event with no data */
#endif
       Stats[NULLEVENTS]++;
       return;
   }

//   check that the event will fit into the output buffer
//   allow for the start event token and possibly an end block token

#ifdef USESHORT
#ifdef USETHREADS
  if (((OutputBufferLen[ID] + EventBufferLen[ID] + 4) << 1) >= Output_Buffer_Length)
#else
  if (((OutputBufferLen[0] + EventBufferLen + 4) << 1) >= Output_Buffer_Length)
#endif
#endif

#ifdef USEINT
#ifdef USETHREADS
  if (((OutputBufferLen[ID] + EventBufferLen[ID] + 2) << 2) >= Output_Buffer_Length)
#else
  if (((OutputBufferLen[0] + EventBufferLen + 2) << 2) >= Output_Buffer_Length)
#endif
#endif

   {

/*    output buffer full   */

#ifdef USETHREADS
      xfer_block(ID);
#else
      xfer_block(0);
#endif
   }

#ifdef USETHREADS
   ptr1 = &OutputBufferAddr[ID][OutputBufferLen[ID]];
#else
   ptr1 = &CurrentOutputBuffer[0][OutputBufferLen[0]];
#endif

#ifdef USESHORT
   *ptr1++ = 0xffff;
#ifdef USETHREADS
   *ptr1++ = (EventBufferLen[ID] << 1) + 4;
   OutputBufferLen[ID] += 2;
#else
   *ptr1++ = (EventBufferLen << 1) + 4;
   OutputBufferLen[0] += 2;
#endif
#endif

#ifdef USEINT
#ifdef USETHREADS
   *ptr1++ = 0xffff0000 + (EventBufferLen[ID] << 2) + 4;
   OutputBufferLen[ID]++;
#else
   *ptr1++ = 0xffff0000 + (EventBufferLen << 2) + 4;
   OutputBufferLen[0]++;
#endif
#endif

/*    copy current event into the output buffer   */

#ifdef USETHREADS
   ptr2 = &EventBuffer[ID][0];
   len = EventBufferLen[ID];
#else
   ptr2 = EventBufferAddr;
   len = EventBufferLen;
#endif

   while (len--) {*ptr1++ = *ptr2++;}

#ifdef USETHREADS
   OutputBufferLen[ID] += EventBufferLen[ID];
#else
   OutputBufferLen[0] += EventBufferLen;
#endif

}

/* --------------------------------------------------------------------- */

#ifndef USETHREADS
void xfer_EXOGAM_event()
{
   unsigned short *ptr1, *ptr2;
   int len, eventheaderwords, subeventheaderwords ; 

//   for this to format correctly when using INT buffers (eventheaderwords + subeventheaderwords) should be even

//   check that the formatted event will fit into the output buffer

   eventheaderwords = 2 + EXOGAM_EVENT_HEADER_STATUS_WORDS + EXOGAM_EVENT_HEADER_EVNUM_WORDS;
   subeventheaderwords =   2 + EXOGAM_SUBEVENT_HEADER_STATUS_WORDS + EXOGAM_SUBEVENT_HEADER_EVNUM_WORDS + EXOGAM_SUBEVENT_HEADER_CLOCK_WORDS;

#ifdef USESHORT
  if ((((OutputBufferLen[0] + EventBufferLen)  + eventheaderwords + subeventheaderwords + 2) << 1) >= Output_Buffer_Length)
#endif

#ifdef USEINT
  if (((((OutputBufferLen[0] + EventBufferLen) << 1)  + eventheaderwords + subeventheaderwords + 2) << 1) >= Output_Buffer_Length)
#endif
   {

/*    output buffer full   */

      xfer_block(0);
   }

/*    build the event header */

   ExogamCurrentOutputBuffer = (unsigned short *) CurrentOutputBuffer;
   ptr1 = &ExogamCurrentOutputBuffer[ExogamOutputBufferLen];

    *ptr1++ = EXOGAM_START_EVENT_TOKEN;

#ifdef USESHORT
    *ptr1++ = EventBufferLen + eventheaderwords + subeventheaderwords;
#endif

#ifdef USEINT
    *ptr1++ = (EventBufferLen << 1) + eventheaderwords + subeventheaderwords;
#endif

      switch(EXOGAM_EVENT_HEADER_STATUS_WORDS)
        {
        case 0:
          break;
        case 1:
          *ptr1++ = 0;
          break;
        case 2:
          *ptr1++ = 0;
          *ptr1++ = 0;
          break;
        case 3:
          *ptr1++ = 0;
          *ptr1++ = 0;
          *ptr1++ = 0;
          break;
            }

      switch(EXOGAM_EVENT_HEADER_EVNUM_WORDS)
        {
        case 0:
          break;
        case 1:
          *ptr1++ = EventNumberLSW;
          break;
        case 2:
          *ptr1++ = EventNumberMSW;
          *ptr1++ = EventNumberLSW;
          break;
        case 3:
          *ptr1++ = 0;
          *ptr1++ = EventNumberMSW;
          *ptr1++ = EventNumberLSW;
          break;
        }

/*    build the sub-event header  */

#ifndef TIARA
    *ptr1++ = EXOGAM_START_SUBEVENT_TOKEN;
#else
    *ptr1++ = EXOGAM_START_SUBEVENT_TOKEN + 0x0800;   /* add in TIARA detector system id */
#endif

#ifdef USESHORT
    *ptr1++ = EventBufferLen + subeventheaderwords;
#endif

#ifdef USEINT
    *ptr1++ = (EventBufferLen << 1) + subeventheaderwords;
#endif

      switch(EXOGAM_SUBEVENT_HEADER_CLOCK_WORDS)
    {
    case 0:
      break;
    case 1:
      *ptr1++ = 0;
      break;
    case 2:
      *ptr1++ = 0;
      *ptr1++ = 0;
      break;
    case 3:
      *ptr1++ = 0;
      *ptr1++ = 0;
      *ptr1++ = 0;
      break;
    }

      switch(EXOGAM_SUBEVENT_HEADER_STATUS_WORDS)
    {
    case 0:
      break;
    case 1:
      *ptr1++ = 0;
      break;
    case 2:
      *ptr1++ = 0;
      *ptr1++ = 0;
      break;
    case 3:
      *ptr1++ = 0;
      *ptr1++ = 0;
      *ptr1++ = 0;
      break;
    }

      switch(EXOGAM_SUBEVENT_HEADER_EVNUM_WORDS)
        {
        case 0:
          break;
        case 1:
          *ptr1++ = EventNumberLSW;
          break;
        case 2:
          *ptr1++ = EventNumberMSW;
          *ptr1++ = EventNumberLSW;
          break;
        case 3:
          *ptr1++ = 0;
          *ptr1++ = EventNumberMSW;
          *ptr1++ = EventNumberLSW;
          break;
        }

/*    copy current event into the output buffer   */

   ptr2 = (unsigned short *) EventBufferAddr;

#ifdef USESHORT
   len = EventBufferLen;
#endif

#ifdef USEINT
   len = EventBufferLen << 1;
#endif
 
   if (len > 0) {
       while (len--) {*ptr1++ = *ptr2++;}
   }

#ifdef USESHORT
   ExogamOutputBufferLen += EventBufferLen + eventheaderwords + subeventheaderwords;
   OutputBufferLen[0] = ExogamOutputBufferLen;
#endif

#ifdef USEINT
   ExogamOutputBufferLen += (EventBufferLen << 1) + eventheaderwords + subeventheaderwords;
   OutputBufferLen[0] = (ExogamOutputBufferLen + 1) >> 1;
#endif

}
#endif
/* --------------------------------------------------------------------- */

#ifndef USETHREADS
void xfer_MBS_event(int trigger)
{

//       MBS format is used only for VXI data - ie with USEINT

#ifdef USEINT
   int len;

   MBS_HEADER * ptr3;
   unsigned int *ptr1, *ptr2;

//   check that the event will fit into the output buffer

   if (((OutputBufferLen[0] + EventBufferLen + 6) << 2) >= Output_Buffer_Length)
   {

/*    output buffer full   */

      xfer_block(0);
   }

   ptr3 = (MBS_HEADER*) &CurrentOutputBuffer[0][OutputBufferLen[0]];

   if (trigger == 1) {
       ptr3->mbs_dlen = ((EventBufferLen + 1) * 2) + 2;       /*  data length (units = 16 bits) */
   } else {
       ptr3->mbs_dlen = 2;
   }

   ptr3->mbs_subtype = 1;     /*  Using MBS Subevent Type 10, Subtype 1 */
   ptr3->mbs_type = 10;
   ptr3->mbs_control = 37;    /*  Nik's choice  */
   ptr3->mbs_subcrate = 0;
   ptr3->mbs_procid = trigger;      /* trigger type - normal data  */

   OutputBufferLen[0] += 3;

   if (trigger != 1) return;
   
/*    copy current event into the output buffer   */

   ptr1 = &CurrentOutputBuffer[0][OutputBufferLen[0]];
   
   *ptr1++ = MBS_SubSysID;    /*   MBS subevent starts with the sub-system ID  */
   OutputBufferLen[0]++;

   if (EventBufferLen > 0) {

       ptr2 = EventBufferAddr;
       len = EventBufferLen;
       while (len--) {*ptr1++ = *ptr2++;}

       OutputBufferLen[0] += EventBufferLen;
   }

#endif
}

#endif

/* --------------------------------------------------------------------- */

#ifdef USETHREADS
void xfer_event(int ID, int flag)
#else
void xfer_event(int flag)
#endif
{
    int i;
    int datastream;

/*

      flag  -  low 4 bits (0:3)

      flag = 0    normal
      flag = 1    STOP
      flag = 2    START

      flag  -   (4:7)
     
        0 -  base data stream
        1 -  2nd data stream 
*/

   datastream = (flag >> 4) & 7;
   flag = flag & 7;

   if (datastream > 1) {return;}    /*  data transfer not supported  */

   if (datastream == 0 && *dacq_TxEnable == 0) {return;}    /*  data transfer not enabled  */
   if (datastream == 1 && *dacq_Tx2Enable == 0) {return;}    /*  data transfer not enabled  */

      if(*dacq_Trace == 1) {
#ifdef USETHREADS
          printf("xfer_event stream %d for event of length %d - output buffer contains %d\n", datastream, EventBufferLen[ID], OutputBufferLen[ID]);
#else
          printf("xfer_event stream %d for event of length %d - output buffer contains %d\n", datastream, EventBufferLen, OutputBufferLen[datastream]);
#endif
      }
   
/*
      Move the current event into the output buffer
*/

     if (flag != 0) {
#ifndef USETHREADS
          if (Format_Option == 2 && flag == 1) xfer_MBS_event(15);   /*  STOP */
          if (Format_Option == 2 && flag == 2) xfer_MBS_event(14);   /*  START */
#endif
          if (flag == 2) Block_Sequence_Number = 0;
        return;
     }

#ifdef USETHREADS
   if (EventBufferLen[ID] == 0 && *dacq_IgnoreNullEvents == 1)  {   /* ignore event with no data */
#else
   if (EventBufferLen == 0 && *dacq_IgnoreNullEvents == 1)  {   /* ignore event with no data */
#endif
       Stats[NULLEVENTS]++;
       return;
   }

#ifdef USESHORT
#ifdef USETHREADS
  if (((EventBufferLen[ID] + 4) << 1) >= Output_Buffer_Length) {
#else
  if (((EventBufferLen + 4) << 1) >= Output_Buffer_Length) {
#endif
#endif

#ifdef USEINT
#ifdef USETHREADS
  if (((EventBufferLen[ID] + 2) << 2) >= Output_Buffer_Length) {
#else
  if (((EventBufferLen + 2) << 2) >= Output_Buffer_Length) {
#endif
#endif

       Stats[TOOBIG]++;
       printf ("xfer_event: event is too big for output buffer  (%d >= %d); ignored\n", EventBufferLen, Output_Buffer_Length);
       return;
   }
   

//    select the procedure for current formatting option

   i = *dacq_MultFactor;     /* may be > 1 for tests */
   while (i-- > 0) {

       switch (Format_Option) {
         case 4:            /*  GREAT/RAW  */
#ifdef USETHREADS
            xfer_RAW_event(ID, datastream);
#else
            xfer_RAW_event(datastream);
#endif
            break;
         case 1:            /*  exogam  */
#ifndef USETHREADS
            xfer_EXOGAM_event();
#endif
            break;
         case 2:           /*   MBS  -  rising   */
#ifndef USETHREADS
            xfer_MBS_event(1);
#endif
            break;
         case 3:            /*  eurogam   -  MIDAS default formatting  */
#ifdef USETHREADS
            xfer_EUROGAM_event(ID);
#else
            xfer_EUROGAM_event();
#endif
            break;
       }
       
       Block_Event_Count++;
   }
}

/* --------------------------------------------------------------------- */

