

/*    first support for obtaining crc  (see Data packet formsat )  */
#include <FEBEX_crc.c>


#define poly 0x1021     /*  crc-ccitt mask */
    
     void update_crc(uint8_t);
     void initialise_crc();
     void finalize_crc();
     
     uint8_t W[12];
     uint16_t CRC;
     
     
    unsigned int PU=0;               /*    Pile Up bit   */
    unsigned int GT=0;                /*  Global Trigger bit   */
    unsigned int padding=0;          /*  must be 2 zero bits  */
    
    uint64_t  ChTime = 0;
    uint32_t  BinNum = 0;     
     

/*
 * 
Data packet format:

W0	0xa5a5
W1	[chan] & "00"  & [GT] & [PF]  &  Timestamp (55 => 48)
W2	Timestamp (47 => 32)
W3	Timestamp (31 => 16)
W4	Timestamp (15 => 00)
W5	Uenergy   (31 => 16)
W6	Uenergy   (15 => 00)
W7	0x5555  or  CRC  (later firmwares)

*/

void  febex_formatJLdata() {
  
/*    check the incoming data format and convert to TDR  output format
 *    this variant assumes that the incoming data is in the format generated by the firmware of James Lawson
 */
  
    int i,j,k;
    int rc;
    int Err;
    
    uint16_t * itembuffer16;
    uint32_t * itembuffer32;
    uint16_t dataitem16;
    uint32_t dataitem32;
    
    uint64_t chTS5548, chTS4732, chTS3116, chTS1500;   /*  channel timestamp  */
    uint64_t ThisTime=0;
    uint64_t TimeDiff = 0;
    
    uint16_t Uenergy3116, Uenergy1500;    /*  channel energy  */
    uint32_t Uenergy=0;

    int32_t len32;      /* units 32 bits */
    int16_t len16;    /* units 16 bits */
    uint16_t items16;
    uint32_t items32;
    
    uint16_t   Data16;
    uint32_t   Data32;
    
    unsigned int group;
    unsigned int item;  
    

    
/*  
     generates output data for the histogramming in evntbuffer & evntbufferlen
 
    evntbuffer = (unsigned int *) EventBufferAddr; 
    evntbufferlen = 0;
*/

    sigtrapset ("Error formatting data buffer");
    
/*    receives input data from febex_readevent in databuffer & databufferlen  */
    		
        itembuffer32 = (uint32_t *) &databuffer[0];
        itembuffer16 = (uint16_t *) &databuffer[0];
	len32 =  databufferlen;
	len16 = databufferlen * 2;
	
if(*dacq_Trace > 0)printf("0JL 0x%x 0x%lx  %d %d\n",*itembuffer16, *itembuffer32, len16, len32);

if(*dacq_Trace > 3)printf("data = 0x%08x 0x%08x 0x%08x 0x%08x 0x%08x 0x%08x 0x%08x 0x%08x 0x%08x 0x%08x \n", databuffer[0], databuffer[1], databuffer[2], databuffer[3],  databuffer[4], databuffer[5], databuffer[6], databuffer[7], databuffer[8], databuffer[9]);

        Stats[COUNT0] = Stats[COUNT0] + len32;
	Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + COUNT0 ] += len32;
	
lab1:

        if (len16 < 8) {len16=0;} 

        while (len16 > 0)
	{
	  
	   dataitem32 = (*itembuffer16++ & 0xffff) | ((*itembuffer16++ << 16) & 0xffff0000);
	   len16-=2;
	   
           if(*dacq_Trace > 2) printf("1 0x%x %d %d\n",dataitem32, len16, databufferlen);

	   if ((dataitem32 & 0xff000034) != 0xff000034) {
	        if(*dacq_Trace > 2) printf ("error 1 %d 0x%x\n",len16,dataitem32);
	        Stats[COUNT1]++;
	        Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + COUNT1]++;
		goto lab1;  
	   }
	   
	     modID = (dataitem32 >> 16) & 15;
	     sfpID = (dataitem32 >> 12) & 3;
	     trigID = (dataitem32 >> 8) & 15;	   
	   
	   dataitem32 = (*itembuffer16++ & 0xffff) | ((*itembuffer16++ << 16) & 0xffff0000);
	   len16-=2;
           items16 = dataitem32/2;

             if (items16 < 4 || items16 > len16) {   /* invalid length for real data  */
	        if(*dacq_Trace > 2) printf ("error 1.1 %d %d\n",items16,len16);
		if (items16 != 0) {
	           Stats[COUNT2]++;
	           Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + COUNT2]++;
		}
                goto lab1;
	     }
	     	    
	    if(*dacq_Trace > 2) printf("1.2 0x%x 0x%x\n",*itembuffer16, dataitem32);
	     
	     Stats[SUMHDR]++;
	     Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + SUMHDR]++;	  
	    
             if(*dacq_Trace > 2) printf("2.0  0x%x 0x%x %d %d %d %d %d %d\n",*itembuffer16, dataitem32, len32, items16, len16, modID, sfpID, trigID);
	     
	     if (items16 < 8 || items16 > len16 | ((items16/8)*8) != items16) {    /*  invalid length for data  */
	           if(*dacq_Trace > 2)printf("1.3.1  %d %d\n",len16, items16);    
	           Stats[COUNT2]++;
	           Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + COUNT2]++;		    
                   goto lab1;
	     }
	     
	     if (items16 < 8 || items16 > len16 ) {    /*  invalid length for data  */
	            if(*dacq_Trace > 2)printf("1.3.2 %d %d\n",len16, items16);
		    Stats[COUNT2]++;
	            Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + COUNT2]++;
                    goto lab1;
	     }
	 
	     if(*dacq_Trace > 2)printf("1.4 0x%x 0x%lx 0x%x %d %d\n",*itembuffer16, dataitem32, dataitem16, len16, items16);
 
      for (k = 0; k < items16; k+=8) { 
      
         if (*dacq_Trace > 2) printf("1.5 0x%x 0x%x 0x%x %d %d %d %d\n",*itembuffer16, dataitem32, dataitem16, items16, len16, k, i);
      
      for (i = 0; i < 8;) {  

	if (len16 < 8) goto lab1;
	
lab3:

	dataitem16 = *itembuffer16++;
	len16--;
		
	if (*dacq_Trace > 2)printf("1.6 0x%x 0x%x 0x%x %d %d %d %d\n", *itembuffer16, dataitem32, dataitem16, items16, len16, k, i);
	
		if (len16 == 0)  goto lab1;
	      
	     if (i == 0) {       /*  W0   */
	 	 if (dataitem16 != 0xa5a5 ) {
		    if(*dacq_Trace > 2) printf("3.2.4.1 0x%x != 0xa5a5\n",dataitem16);
	            Stats[BAD0]++;
	            Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + BAD0]++;
		    goto lab3;
	         }
	         goto lab2;
	     }
	     
	      if (i == 1) {       /*  W1   */
	         W[0] = (dataitem16 >> 8) & 255;
		 W[1] = dataitem16 & 255; 		
		chID = (dataitem16 >> 12) & 15;
		padding = (dataitem16 >> 8) & 0xc;
		PU = (dataitem16 >> 8) & 1;
		GT = (dataitem16 >> 9) & 1;
		chTS5548 = dataitem16 & 0x00ff;
	
		if(*dacq_Trace > 2) printf("3.2.4.2 0x%x %d\n",dataitem16, chID);
		
		if (padding != 0x0 ) {
		 if(*dacq_Trace > 2) printf("3.2.4.4 0x%x != 0x0\n",dataitem16);
	         Stats[BAD2]++;
	         Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + BAD2]++;
		 goto lab1;
	        }
	        
		if (PU == 1 ) {
		 if(*dacq_Trace > 2) printf("3.2.4.5 0x%x != 0\n",dataitem16);
	         Stats[PUBIT]++;
	         Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + PUBIT]++;
		}
		if (GT == 1 ) {
		 if(*dacq_Trace > 2) printf("3.2.4.6 0x%x != 0\n",dataitem16);
	         Stats[GTBIT]++;
	         Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + GTBIT]++;
		}
		goto lab2;
	     }
	     
	     if (i == 2)  {   /*   W2   */
	         W[2] = (dataitem16 >> 8) & 255;
		 W[3] = dataitem16  & 255; 	        
	       chTS4732 = dataitem16;
		 goto lab2;
	     }
	     
	     if (i == 3)  {   /*   W3  */
	         W[4] = (dataitem16 >> 8) & 255;
		 W[7] = dataitem16 & 255; 	        
	       chTS3116 = dataitem16;
		 goto lab2;
	     }
	           
	     if (i == 4)  {   /*   W4  */
	         W[6] = (dataitem16 >> 8) & 255;
		 W[7] = dataitem16 & 255; 	        
	       chTS1500 = dataitem16;
		 goto lab2;
	     }
	     
	     if (i == 5)  {   /*   W5   */
	         W[8] = (dataitem16 >> 8) & 255;
		 W[9] = dataitem16 & 255; 	        
	       Uenergy3116 = dataitem16;
		 goto lab2;
	     }
	     
	     if (i == 6)  {   /*   W6   */
	         W[10] = (dataitem16 >> 8) & 255;
		 W[11] = dataitem16 & 255; 	        
	       Uenergy1500 = dataitem16;
		 goto lab2;
	     }	     
	     
	     if (i == 7)  {   /*   W7   */
	        obtain_crc();
		 if (dataitem16 != CRC ) {
	            if(*dacq_Trace > 2) printf("3.1.9 0x%x != 0x%x\n",dataitem16, CRC);
	            Stats[BAD4]++;
	            Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + BAD4]++;
//	   	    goto lab1;
	         }
	         else {
		    if(*dacq_Trace > 2) printf("3.1.9 0x%x == 0x%x\n",dataitem16, CRC);
	            Stats[BAD1]++;
	            Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + BAD1]++;
		 }
	       goto lab2;
	     }
	    
lab2:        i++;
	     
	  }     /*   end of   for (i=0; i< 8; i++)   */
	  


      
               if(*dacq_Trace > 2) printf("1.7  0x%x 0x%lx 0x%x %d %d\n", *itembuffer16, dataitem32, dataitem16, items16, len16);
	  
	  
	       ThisTime = (chTS5548 << 48) | (chTS4732 << 32) | (chTS3116 << 16) | chTS1500;
	       
               if(*dacq_Trace > 2) printf("3.2.5 0x%x 0x%x 0x%x 0x%x ThisTime = 0x%llx ChTime = 0x%llx\n",chTS5548, chTS4732, chTS3116, chTS1500, ThisTime, ChTime);

	       if (ThisTime == 0xffffffffffff) {ThisTime = ChTime;}

               if (ThisTime < ChTime) {
		 
               if(*dacq_Trace > 2) printf("3.2.6.1 0x%x 0x%x 0x%x 0x%x 0x%llx 0x%llx\n",chTS5548, chTS4732, chTS3116, chTS1500, ThisTime, ChTime);

                  Stats[BAD5]++;
	          Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + BAD5]++;
		  
		  ChTime = ThisTime;

	       }
	       
               if (ThisTime == ChTime) {
		 
                 if(*dacq_Trace > 2) printf("3.2.6.2 0x%x 0x%x 0x%x 0x%x 0x%llx 0x%llx\n",chTS5548, chTS4732, chTS3116, chTS1500, ThisTime, ChTime);

                  Stats[BAD5]++;
	          Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + BAD5]++;
		  
		  ChTime = ThisTime;
		  
	       }
	       
	       TimeDiff = ThisTime - ChTime;
	       
	       ChTime = ThisTime;
	       
	      Uenergy = (Uenergy3116 << 16) | Uenergy1500;
	  
		if (Uenergy < FEBEX_EnergyLow)  {
		  if (*dacq_Trace > 2) printf("3.3.1 0x%lx 0x%x\n", Uenergy, FEBEX_EnergyLow);
		  Stats[BAD6]++;
		  Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + BAD6]++;
		}
		  
		if (Uenergy > FEBEX_EnergyHigh)  {
		  if (*dacq_Trace > 2) printf("3.3.2 0x%lx 0x%lx\n", Uenergy, FEBEX_EnergyHigh);
		  Stats[BAD7]++;
		  Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + BAD7]++;
		}
		
if(*dacq_Trace > 2)printf("3.1 %d %d 0x%x 0x%llx 0x%llx 0x%llx 0x%llx 0x%llx 0x%lx\n",len32, len16, chID, chTS5548, chTS4732, chTS3116, chTS1500, ChTime, Uenergy); 

		/*    generate output data in TDR format    */
		/*    evntbuffer and evntbufferlen  define a buffer of ints for the TDR format data passed back to interrupt.c */
		
/*
*  data items 
*     =0         32 bit Uenergy energy bined into 16 bits
*     =2         Uenergy 1500
*     =3         Uenergy 3116
*     =1         16 bit time difference since previous data group 
*/


		BinNum = (Uenergy - FEBEX_EnergyLow)/FEBEX_BinSize;
		
		if (GT == 0) {
		
		Data32 = (2 << 30) | (sfpID << 28) | (modID << 24) | (7 << 20) | ((ChTime >> 28) & 0x000fffff);   // Info item code=7  time 28 => 47
		
	if(*dacq_Trace > 2)printf ("6.01 0x%lx 0x%llx\n", Data32, ChTime);

		*evntbuffer++ = Data32;
		evntbufferlen++;
		*evntbuffer++ = ((int)ChTime & 0x0fffffff); 
		evntbufferlen++;

		Data32 = (2 << 30) | (sfpID << 28) | (modID << 24) | (8 << 20) | ((ChTime >> 48) & 0x0ff);        // Info item code=8  time 48 => 55
		
        if(*dacq_Trace > 2)printf ("6.02 0x%lx 0x%llx\n", Data32, ChTime);

		*evntbuffer++ = Data32;
		evntbufferlen++;
		*evntbuffer++ = ((int)ChTime & 0x0fffffff); 
		evntbufferlen++;
	
	        }

                if (GT == 1) {     //  global trigger bit - generate Info item code=14  & 15
		  
		   Data32 = (2 << 30) | (sfpID << 28) | (modID << 24) | (14 << 20) | ((ChTime >> 28) & 0x000fffff);  // Info item code=14

		   *evntbuffer++ = Data32;
		   evntbufferlen++;
		   *evntbuffer++ = ((int)ChTime & 0x0fffffff); 
	  	   evntbufferlen++;
		   
		   Data32 = (2 << 30) | (sfpID << 28) | (modID << 24) | (15 << 20) | ((ChTime >> 48) & 0x0ff);        // Info item code=15

		   *evntbuffer++ = Data32;
		   evntbufferlen++;
		   *evntbuffer++ = ((int)ChTime & 0x0fffffff); 
	  	   evntbufferlen++;
		}
		   
	     Stats[CHHDR]++;
	     Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + CHHDR]++;	
	     
	        if (GT == 1) goto lab99;

		item = 0;
		group = (modID * 16) + chID + 1;

		Data32 = (3 << 30) | (PU << 29) | (sfpID << 26) | (modID << 22) | (item << 20) | (chID << 16) | ((int)BinNum & 0x0ffff);   // channel energy word (int)  
		
if(*dacq_Trace > 2) printf ("6.0 0x%x %d %d 0x%x 0x%x %d\n", Data32, group, item, Uenergy, FEBEX_BinSize, BinNum);

                *evntbuffer++ = Data32;
		evntbufferlen++;
		*evntbuffer++ = ((int)ChTime & 0x0fffffff); 
		evntbufferlen++;
/*
                item = 1;
		group = (modID * 16) + chID + 1;

		Data32 = (3 << 30) | (sfpID << 26) | (modID << 22) | (item << 20) | (chID << 16) | ((int)TimeDiff & 0x0ffff);   // channel time word (int)  
		
if(*dacq_Trace > 2)printf ("6.1 0x%x %d %d\n", Data32, group, item);

                *evntbuffer++ = Data32;
		evntbufferlen++;
		*evntbuffer++ = ((int)ChTime & 0x0fffffff); 
		evntbufferlen++;
*/

/*

		item = 2;
                group = (modID * 16) + chID + 1;

		Data32 = (3 << 30) | (sfpID << 26) | (modID << 22) | (item << 20) | (chID << 16) | ((int)Uenergy1500 & 0x0ffff);   // channel energy word (32 unsigned low) 
		
if(*dacq_Trace > 2)printf ("6.2 0x%x %d %d\n", Data32, group, item);

                *evntbuffer++ = Data32;
		evntbufferlen++;
		*evntbuffer++ = ((int)ChTime & 0x0fffffff);
		evntbufferlen++;


		item = 3;
		group = (modID * 16) + chID + 1;

		Data32 = (3 << 30) | (sfpID << 26) | (modID << 22) | (item << 20) | (chID << 16) | ((int)Uenergy3116 & 0x0ffff);   // channel energy word (32 unsigned high)
		
if(*dacq_Trace > 2)printf ("6.3 0x%x %d %d\n", Data32, group, item);

                *evntbuffer++ = Data32;
		evntbufferlen++;
		*evntbuffer++ = ((int)ChTime & 0x0fffffff);
		evntbufferlen++;
*/
		
lab99:  continue;
		
	  }   /*   end of    for (k=0; k<items16; k+=8)  */
           
if(*dacq_Trace > 1)printf ("8 End of  FEBEX readevent %d  %d\n", len16, evntbufferlen);	  
	
        }  /*  end of   while (len16 > 0)  */
        
     EventBufferLen =  evntbufferlen;   /* for the histogrammer code  */

if(*dacq_Trace > 1)printf ("9 End of  FEBEX readevent %d\n", EventBufferLen);
    
    sigtrapset ("Error detected during data acquisition");

    return;

}	     
	     
	     
	     
	     
	     
	     
