

void  febex_formatMBSdata() {
  
/*    check the incoming data format and convert to TDR  output format
 *    this variant assumes that the incoming format is in the original MBS structure 
 */
  
    int i;
    int rc;
    int module = 0;
    
    unsigned int * itembuffer;
    int dataitem;
    
/* 
    int ChEnergy[15];    //  channel energy
    int ChTime[15];
*/
    int EvCounter;
    
    int len;
    int items;
    int ChID;
    int tracelen;
    
    uint32_t   Data32;
    uint16_t   Data16;

 
    evntbuffer = (unsigned int *) EventBufferAddr;     /* output data  */
    evntbufferlen = 0;


    sigtrapset ("Error formatting data buffer");
    
/*    receives input data from febex_readevent in databuffer & databufferlen  */
    
		
        itembuffer = &databuffer[0];
	len =  databufferlen;
	
if(*dacq_Trace > 1)printf("0MBS 0x%x %d \n",*itembuffer, len);	

        while (len > 0)
	{
	   dataitem = *itembuffer++;
	   len--;
	   
if(*dacq_Trace > 3) printf("1 0x%x %d \n",dataitem, len);
	   
	   if ((dataitem & 0x00000034) == 0x00000034) {   /*  valid channel header */
	     
	     sfpID = (dataitem >> 12) & 3;
	     trigID = (dataitem >> 8) & 15;
	     modID = (dataitem >> 16) & 63;
	     chID = (dataitem >> 24) & 15;
	     
	     Stats[CHHDR]++;
	     Stats[((sfpID * MAX_SLAVE) + modID + 1) * MAXCOUNTERS + CHHDR]++;
	    
	     items = (*itembuffer++ + 3)/4;   /* channel length in 32 bit words  */
	     len--;
	     
if(*dacq_Trace > 2)printf("2 0x%x %d %d\n",dataitem, len, items);

             if (items > len) {
		 if(*dacq_Trace > 2) printf("data format error #1 detected in formatMBSdata!!!  0x%x > %d\n",items, len); 
		 goto L9;
	     }
 
if(*dacq_Trace > 2)printf("3.2 0x%x %d \n",*itembuffer, len);
	     
		dataitem = *itembuffer++;   /*   trace data header 0xAnyyzzzz    */
		EvCounter = dataitem & 0x0000ffff;
		len--;
		
		tracelen = ((items - 4) + 3) / 4;      /*    length in 32 bit words */
		
if(*dacq_Trace > 2)printf("4 %d 0x%x %d %d 0x%x %d\n",chID, dataitem, len, items, items, tracelen);

                if (tracelen > len) {
		    if(*dacq_Trace > 1) printf("data format error #2 detected in formatMBSdata!!!  0x%x > %d\n",tracelen, len); 
		    goto L9;
		}

if(*dacq_Trace > 2)printf("5 %d %d %d %d\n",modID, chID, tracelen, ((((tracelen + 1)/2)*2)*4) );

                /*    generate output data in TDR format    */
		/*    evntbuffer and evntbufferlen  define a buffer of ints for the TDR format data passed back to interrupt.c */

		/*    build a trace data item from this itembuffer   */
		/*    note that the number of samples (items) is a muliple of 4  (64 bits) */

		Data32 = (1 << 30) | (modID << 24) | (0 << 21) | (chID << 16) | ((((tracelen + 1)/2)*2)*2);

if(*dacq_Trace > 2)printf ("6 0x%x\n", Data32);

                *evntbuffer++ = Data32;
		evntbufferlen++;
		*evntbuffer++ = Time[chID];       /*  awaiting firmware  */
		evntbufferlen++;
		
		for (i=0; i<tracelen; i++) {
	            Data32 = *itembuffer++;
		    *evntbuffer++ = ((Data32 & 0x0000ffff) << 16) | ((Data32 >> 16) & 0x0000ffff);
	            evntbufferlen++;
		    len--;
		}
		if ((evntbufferlen & 1) == 1) {*evntbuffer++ = 0; evntbufferlen++;}     /*  round up if needed  */
		
		EventBufferLen = evntbufferlen;
		
		dataitem = *itembuffer++;   /*   trace data trailer 0xBnyyzzzz    */
		EvCounter = dataitem & 0x0000ffff;
		len--;
		
if(*dacq_Trace > 2)printf ("7 done %d\n", EventBufferLen);
if(*dacq_Trace > 2)printf ("8 0x%x\n", *itembuffer);
		
	     }  /*  end of  while ((*itembuffer & 0x000000ff) == 0x00000034)  a trace header */
	
        }  /*  end of   while (len > 0)  */
        
L9:

if(*dacq_Trace > 1)printf ("9 End of  FEBEX readevent %d\n", EventBufferLen);
    
    sigtrapset ("Error detected during data acquisition");

    return;

}



