
#    Note:  This is loaded into the namespace  NETVARS

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

     do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    
    variable PROJECT $::DataAcquisition::PROJECT
    
   variable NetVars
   set NetVars {}
   lappend NetVars "FEBEX_PexorEnable"
   lappend NetVars "FEBEX_Data_In_Enable" 
   lappend NetVars "FEBEX_Data_Out_Enable"
   lappend NetVars "FEBEX_DataFormat"
   lappend NetVars "FEBEX_Do_DataRead"
   lappend NetVars "FEBEX_Do_DataFormat"
   lappend NetVars "FEBEX_DataBase"
   lappend NetVars "FEBEX_DataInFile"
   lappend NetVars "FEBEX_DataOutFile"
   lappend NetVars "NetVar.DACQ.Ctrace"
   lappend NetVars "FEBEX_TokenMode"
   lappend NetVars "FEBEX_ReadOutDelay"
   lappend NetVars "FEBEX_EnergyLow"
   lappend NetVars "FEBEX_EnergyHigh"
   lappend NetVars "FEBEX_BinSize"
   
   
   variable Use
   set Use {}
   lappend Use  "Enable (=1) raw data read from FEBEX hardware; Disable (=0) would expect Data_In_Enable = 1"
   lappend Use  "Enable (=1) raw data read from disc file written earlier; Disable (=0) would expect PexorEnable = 1"
   lappend Use  "Enable (=1) raw data write to disc file which can be used later with Data_In_Enable = 1; expects PexorEnable = 1"
   lappend Use  "=0 raw data in MBS format (Standard Mode) for Data Traces; =1 raw data in FEBEX Fast readout format"
   lappend Use  "=0 debug mode - Data readout is not performed"
   lappend Use  "=0 debug mode - Data formatting is not performed" 
   lappend Use  "File store base directory for Data_In and Data_Out storage" 
   lappend Use  "File name used in the above directory for Data_In" 
   lappend Use  "File name used in the above directory for Data_Out" 
   lappend Use  "sets the degree of diagnostic trace output - =0 is none"
   lappend Use  "Option to be used for token passing in GOSIP readout"
   lappend Use  "Delay between data read requests when polling"
   lappend Use  "sets the low limit for the UEnergy"
   lappend Use  "sets the high limit for the UEnergy"
   lappend Use  "sets the size of a bin for the UEnergy"

   
   variable Value
   set Value {0 0 0 0 0 0 0 0 0 0 0 0 0 0 0}
   

   proc  show_variables {} {
       global env
       variable NetVars
       variable Value
       variable PROJECT
       
       
      InsertLog "[file join $env(MIDASBASE) DB [set ::[set PROJECT]::DBRootName] [set ::[set PROJECT]::DBNodeBase] [set ::[set PROJECT]::DBNodeName] FEBEXNetVars]"
       
       foreach item $NetVars {InsertLog "$item"}
       InsertLog "$Value"
       
       
       InsertLog "$PROJECT     $::FEBEX::DBRootName   $::FEBEX::DBNodeBase   $::FEBEX::DBNodeName"

       
       set rc [catch {ReadNetVar FEBEX_PexorEnable} m]
       InsertLog "$rc $m"
   }

   proc do_setOpt {name vl} {
#InsertLog "$name $vl"
         WriteNetVar $name $vl
         do_Save; do_Restore
   }
 
       proc do_Save {} {
          global env
          variable NetVars
          variable PROJECT
          
          set f [file join $env(MIDASBASE) DB [set ::[set PROJECT]::DBRootName] [set ::[set PROJECT]::DBNodeBase] [set ::[set PROJECT]::DBNodeName] FEBEXNetVars]

          set rc [catch {open $f w} fid]
          if {$rc != 0} then {puts "Cannot create $f - $fid"; return}
          
          set rc [catch {file attributes $f -permissions rw-rw-rw-} m]
          if {$rc != 0} then {puts "error accessing $f - $m"}
          
#          foreach item $NetVars {puts $fid "$item [ReadNetVar NetVar.$item]"}
          foreach item $NetVars {puts $fid "$item [ReadNetVar $item]"}
          
          close $fid

#          InsertLog "FEBEX program NetVars saved to $f"

      }

      proc do_Restore {} {
          global env
          variable NetVars
          variable Value
          variable PROJECT
          
          set f [file join $env(MIDASBASE) DB [set ::[set PROJECT]::DBRootName] [set ::[set PROJECT]::DBNodeBase] [set ::[set PROJECT]::DBNodeName] FEBEXNetVars]

          set rc [catch {open $f r} fid]
          if {$rc != 0} then {puts "Cannot access $f - $fid"; return}
          
          set rc [catch {read -nonewline $fid} data]
          close $fid
          if {$rc != 0} then {puts "error accessing $f $data"; return}
          
#          foreach item [split $data \n] {WriteNetVar NetVar.[first $item] [second $item]}
          foreach item [split $data \n] {WriteNetVar [first $item] [second $item]}

          
          set Value {}
#          foreach item $NetVars {lappend Value [ReadNetVar NetVar.[first $item]]} 
          foreach item $NetVars {lappend Value [ReadNetVar [first $item]]}
 
#          InsertLog "FEBEX program NetVars restored from $f"
 
      }
    

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable NetVars

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   
		   HELP     {variable HelpTopic; set HelpTopic Help; do_help}
                   
                   RESTORE  {do_Restore}
                   SAVE     {do_Save}  
                   
                   NVOPT      {do_setOpt  [second [lindex $cgidata 1]]   [third [lindex $cgidata 1]]}
                   NETVARS    {do_setOpt  [lindex $NetVars [string range $vl 7 end]]   [third [lindex $cgidata 1]]}
                   
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }

     }
     
     do_Restore

}   ;# end of if {$started == 0}



