
#    Note:  This is loaded into the namespace  FEBEX_Perf

#    code (int)  state (string)

#       0           stopped
#       1           going
#       2           reset
#       3           setting up
#       4           changing to going
#       5           changing to stopped
#       6           error   
#       7           changing to reset
#       8           undefined 
#       9           executing



# variable started 0

if {![info exists started]} {variable started 0}

global Options
global env

global response

global MIDAS_SpectrumAccessServer_Exists
set MIDAS_SpectrumAccessServer_Exists 1
global SpectrumServerHost
set $env(ComputerName) $SpectrumServerHost

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0
    variable DebugFlag 0

    variable JS ""
    

  global ModuleMenu
  global LinkMenu
  global BoardMenu
  global ChannelMenu
  
  global Options
  
        global FEBEXmodule
        global FEBEXlink
        global FEBEXboard
        global FEBEXchannel 
    
        variable allmodules 0
        variable alllinks 0
        variable allboards 0
     
        variable CModule 0
        variable CLink 0
        variable CBoard 0
        
   variable Status0
   variable Status1
   variable Status2
   variable Status3
   variable Status4
   variable Status5
   variable Status6
   variable Status7
   variable Status8
   variable Status9
   
   set Status0 "stopped"
   set Status1 "running"
   set Status2 "reset"
   set Status3 "setting up"
   set Status4 "changing to going"
   set Status5 "changing to stopped"
   set Status6 "idle"
   set Status7 "idle"
   set Status8 "idle"
   set Status9 "executing"
   
    variable SecsDelay 100
    variable MaxDelay  10

   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
       
        variable CModule
        variable CLink
        variable CBoard
        
        variable allmodules
        variable alllinks
        variable allboards

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "Module=$CModule; Link=$CLink; Board=$CBoard"
        InsertLog "allmodules=$allmodules; alllinks=$alllinks; allboards=$allboards"

   }
     
   proc UpdateModule {} {}
   
   proc do_step0  {} {
     variable Status0
     
     set rc [catch {::DataAcquisitionControl::do_setopt } m]
     if {$rc != 10} {InsertLog "0 response do_setopt =>  rc=$rc  :  $m"}
   
     set rc [catch {::DataAcquisitionControl::do_getSTATE} m]
     if {$rc != 10} {InsertLog "0 response do_getSTATE =>  rc=$rc  :  $m"}
     
     set Status0 $m
     
     set ::DataAcquisition::EnableHistogramming 1
     
     set rc [catch {::DataAcquisitionControl::do_setopt "HistEnable=1"} m]
     if {$rc != 10} {InsertLog "0 response EnableHistogramming =>  rc=$rc  :  $m  : $::DataAcquisition::EnableHistogramming "}
     
     after 5000
     
     set ::DataAcquisition::EnableHistogramming 0
     
     set rc [catch {::DataAcquisitionControl::do_setopt "HistEnable=0"} m]
     if {$rc != 10} {InsertLog "0 response EnableHistogramming =>  rc=$rc  :  $m  :  $::DataAcquisition::EnableHistogramming"}
     
     set Status0 $m
   }
   
   proc do_step1 {} {   
      variable Status1
      variable MaxDelay
  
      set rc [catch {::DataAcquisitionControl::do_RESET} m]
      InsertLog "response do_RESET =>  rc=$rc  :  $m"
      
      set j $MaxDelay
      for {set i 0} {$i < $j} {incr i} {
           set rc [catch {::DataAcquisitionControl::do_getSTATE} m]
 #          InsertLog "response do_getSTATE =>  rc=$rc  :  $m"
           if {$m == 2} {set j 0}
           after 1000
      }
      
     set rc [catch {::DataAcquisitionControl::do_getSTATE} m]
     if {$rc != 10} {InsertLog "0 response do_getSTATE =>  rc=$rc  :  $m"}
     
     set Status1 $m
   }
   
   proc do_step1 {} {   
      variable Status1

     set ::DataAcquisition::EnableHistogramming 0
     
     set rc [catch {::DataAcquisitionControl::do_setopt "HistEnable=0"} m]
     if {$rc != 10} {InsertLog "1.1 response EnableHistogramming =>  rc=$rc  :  $m  :  $::DataAcquisition::EnableHistogramming"}
     
     set rc [catch {::DataAcquisitionControl::do_getopt "HistEnable"} m]
     if {$rc != 10} {InsertLog "1.2 response EnableHistogramming =>  rc=$rc  :  $m  :  $::DataAcquisition::EnableHistogramming"}
   
     set Status1 "Histogramming OFF"
   }
   
   proc do_step2 {} {
      variable Status2
      variable MaxDelay
  
      set rc [catch {::DataAcquisitionControl::do_SETUP} m]
      InsertLog "response do_SETUP =>  rc=$rc  :  $m"
      
      set j $MaxDelay
      for {set i 0} {$i < $j} {incr i} {
           set rc [catch {::DataAcquisitionControl::do_getSTATE} m]
 #          InsertLog "response do_getSTATE =>  rc=$rc  :  $m"
           if {$m == 0} {set j 0}
           after 1000
      }

     set rc [catch {::DataAcquisitionControl::do_getSTATE} m]
     if {$rc != 10} {InsertLog "response do_getSTATE =>  rc=$rc  :  $m"}
     
     set Status2 $m
   }
   
   proc do_step2 {} {
 
     set rc [catch {::DataAcquisitionControl::do_getSTATE} m]
     if {$rc != 10} {InsertLog "response do_getSTATE =>  rc=$rc  :  $m"}
     
     set Status2 $m
   }
   
   
   proc do_step3 {} {
      variable MaxDelay
      variable Status3
  
      set rc [catch {::DataAcquisitionControl::do_GO} m]
      InsertLog "response do_GO =>  rc=$rc  :  $m"
      
      set j $MaxDelay
      for {set i 0} {$i < $j} {incr i} {
           set rc [catch {::DataAcquisitionControl::do_getSTATE} m]
           InsertLog "response do_getSTATE =>  rc=$rc  :  $m"
           if {$m == 1} {set j 0}
           after 1000
      }
      
     set rc [catch {::DataAcquisitionControl::do_getSTATE} m]
     if {$rc != 10} {InsertLog "response do_getSTATE =>  rc=$rc  :  $m"}
     
     set Status3 $m
   }
   
   proc do_step3 {} {
   
     set ::DataAcquisition::EnableHistogramming 1
     
     set rc [catch {::DataAcquisitionControl::do_setopt "HistEnable=1"} m]
     InsertLog "3 response Histogramming ON =>  rc=$rc  :  $m  :  $::DataAcquisition::EnableHistogramming"
     
     set Status3 "Histogramming ON"
     
     set rc [catch {::DataAcquisitionControl::do_getopt "HistEnable"} m]
     if {$rc != 10} {InsertLog "response do_getopt =>  rc=$rc  :  $m"}
   }
   
   
   proc do_step4 {} {
       variable SecsDelay
       
      set start [exec date]
      
      SetFooter "starting.."
      
      do_step3
      
      after [expr ([set SecsDelay] * 1000)]
      
      SetFooter "finishing.."
      
      set finish [exec date]
      
      InsertLog "response $start => $finish"
      
      do_step5
      
      ClearFooter
   
   }
   
   proc do_step5 {} {
      variable Status5
      variable MaxDelay
  
      set rc [catch {::DataAcquisitionControl::do_STOP} m]
      InsertLog "response do_STOP =>  rc=$rc  :  $m"
      
      set j $MaxDelay
      for {set i 0} {$i < $j} {incr i} {
           set rc [catch {::DataAcquisitionControl::do_getSTATE} m]
 #          InsertLog "response do_getSTATE =>  rc=$rc  :  $m"
           if {$m == 0} {set j 0}
           after 1000
      }
      
     set rc [catch {::DataAcquisitionControl::do_getSTATE} m]
     if {$rc != 10} {InsertLog "response do_getSTATE =>  rc=$rc  :  $m"}
     
     set Status5 $m

   }
   
   proc do_step5 {} {
      variable status5
   
     set ::DataAcquisition::EnableHistogramming 0
     
     set rc [catch {::DataAcquisitionControl::do_setopt "HistEnable=0"} m]
     InsertLog "5 response Histogramming OFF =>  rc=$rc  :  $m  :  $::DataAcquisition::EnableHistogramming"
      
     set Status5 "Histogramming OFF"
     
     set rc [catch {::DataAcquisitionControl::do_getSTATE} m]
     if {$rc != 10} {InsertLog "response do_getSTATE =>  rc=$rc  :  $m"}

   }
   
   proc do_step6 {} {
       variable Status6
       
       InsertLog "exec [date]"
       
       do_step1   ;#RESET  Histpgramming OFF
       do_step2   ;#SETUP  no action
       do_step9   ;#ZERO histograms & statistics
       do_step4   ;# timed run   GO  =>   time delay  =>   STOP
       do_step5   ;#       Histogramming OFF
       do_step8   ;# integrate
       do_step7   ;# DAQ counters
       
       InsertLog "exec [date]"
       
     set rc [catch {::DataAcquisitionControl::do_getSTATE} m]
     if {$rc != 10} {InsertLog "6 response do_getSTATE =>  rc=$rc  :  $m"}
     
     set Status6 $m
   }
   
   proc do_step7 {} {
      variable Status7
      
      set rc [catch {::DataAcquisitionStats::do_counters} m]
      InsertLog "7 response do_counters => rc=$rc   :  $m"
     
     set Status7 $m
     
   }
   
   proc do_step8 {} {
      variable Status8

      set rc [catch {interp eval "" ::namespace inscope ::SpectrumServer do_updateSpectrum} m]
      InsertLog "8 response do_update => rc=$rc   :  $m"
      
      set rc [catch {interp eval "" ::namespace inscope ::SpectrumServer do_totalcounts} m];  puts "$m"
      InsertLog "8 response do_integrate => rc=$rc   :  $m"
     
     set Status8 $m
   }
   
  proc do_step9 {} {
      variable MaxDelay
      variable Status9
      
      set rc [catch {::DataAcquisitionControl::do_setopt HistogramZero} m]
      set m "done"
      InsertLog "9 response ZeroHistograms => rc=$rc   :  $m"
      
      set j $MaxDelay
      for {set i 0} {$i < $j} {incr i} {
           set rc [catch {::DataAcquisitionControl::do_getSTATE} m]
           InsertLog "response do_getSTATE =>  rc=$rc  :  $m"
           if {$m == 9} {set j 0}
           after 1000
      }
      
     set rc [catch {::DataAcquisitionControl::do_getSTATE} m]
     if {$rc != 10} {InsertLog "response do_getSTATE =>  rc=$rc  :  $m"}
     
     set Status9 $m
      
      set rc [catch {::DataAcquisitionControl::do_setopt ClearStats} m]
      InsertLog "9 response ClearStats => rc=$rc   :  $m"
      
      set j $MaxDelay
      for {set i 0} {$i < $j} {incr i} {
           set rc [catch {::DataAcquisitionControl::do_getSTATE} m]
           InsertLog "response do_getSTATE =>  rc=$rc  :  $m"
           if {$m == 9} {set j 0}
           after 1000
      }
      
     set rc [catch {::DataAcquisitionControl::do_getSTATE} m]
     if {$rc != 10} {InsertLog "response do_getSTATE =>  rc=$rc  :  $m"}
     
     set Status9 $m

      
   }
   
   
   proc do_execute {n} {
   
      switch  $n  {
          ButtonB0 {do_step0}
          ButtonB1 {do_step1}
          ButtonB2 {do_step2}
          ButtonB3 {do_step3}         
          ButtonB4 {do_step4}
          ButtonB5 {do_step5}
          ButtonB6 {do_step6}
          ButtonB7 {do_step7}
          ButtonB8 {do_step8}
          ButtonB9 {do_step9}

          default  {InsertLog "unexpected switch in do_execute:  $n"} 
      }
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
        variable allmodules
        variable alllinks
        variable allboards
        variable CModule
        variable CLink
        variable CBoard

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]
           set i [second [lindex $cgidata 1]]
           set vl [third [lindex $cgidata 1]]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {}
                VARIABLES {show_variables}


                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}
                
                HELP     {variable HelpTopic; set HelpTopic Help; do_help}                
                
                   MODULE     {SelectFEBEXModule $i; UpdateModule}
                   ALLMODULES {set allmodules [expr ($allmodules + 1) & 1]}
                   LINK     {SelectFEBEXLink $i; UpdateModule}
                   ALLLINKS {set alllinks [expr ($alllinks + 1) & 1]}
                   BOARD     {SelectFEBEXBoard $i; UpdateModule}
                   ALLBOARDS {set allboards [expr ($allboards + 1) & 1]}
                   
                   CMODULE    {set CModule $i}
                   CLINK      {set CLink $i}
                   CBOARD     {set CBoard $i}
                   
                   Perf       {do_execute $i}
      
                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
       
    }

     set html ""


}  ;# end of if {$started == 0}

