
#    Note:  This is loaded into the namespace  FEBEX_SpecSave

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

   do_click

}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1
    
    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0
    variable DebugFlag 0

    variable JS ""
    
    variable AcqSetOption ""
    
    global ChannelMenu
    foreach i $ChannelMenu {variable A$i; set A$i 0}
    variable A01 0
    variable A02 0
    
        variable FEBEXmodule
        variable FEBEXlink
        variable FEBEXboard
        variable FEBEXchannel
        
        variable allmodules 0
        variable alllinks 0
        variable allboards 0

   variable index 0

    variable EOpt "checked"
    variable TOpt " "
    variable WOpt " "
    variable SaveOpt "E"


   proc show_variables {} {
      
        global MIDAS_DataAcquisitionControlServer_Exists
        global Options
        global ChannelMenu
        variable LogFlag
        variable ShowLogFlag
        variable AcqSetOption
        variable SaveOpt

        InsertLog "MIDAS_DataAcquisitionControlServer_Exists=$MIDAS_DataAcquisitionControlServer_Exists"

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "AcqSetOption = $AcqSetOption"
        InsertLog "SaveOpt=$SaveOpt"
        InsertLog "[SpectrumNames]"
   }

    proc do_setopt {option} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        variable AcqSetOption
        global MIDAS_DataAcquisitionControlServer_Exists

        set AcqSetOption $option

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && $MIDAS_DataAcquisitionControlServer_Exists == 1} {

          set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer DoOption "$AcqSetOption"} m]
       } else {

           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__DoOption "$AcqSetOption"} m]
      }

        if {$rc != 0} {
            InsertLog "DO OPTION returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "DO OPTION returned $m ([format "0x%x" $m])"
        }

     }

      proc do_Save {} {
         variable SaveOpt

         InsertLog "Saving FEBEX4A histograms"

         do_setopt "HistogramSave=$SaveOpt"
         
         InsertLog "Done at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"
 
    }

     proc do_SaveOpt {vl} {
        variable EOpt
        variable TOpt
        variable WOpt
        variable SaveOpt 

         switch $vl {
            E   {if {$EOpt == "checked"} {set EOpt " "} else {set EOpt "checked"}}
            T   {if {$TOpt == "checked"} {set TOpt " "} else {set TOpt "checked"}}
            W   {if {$WOpt == "checked"} {set WOpt " "} else {set WOpt "checked"}}
         }

         set SaveOpt ""
         if {$EOpt == "checked"} {append SaveOpt "E"}
         if {$TOpt == "checked"} {append SaveOpt "T"}
         if {$WOpt == "checked"} {append SaveOpt "W"}
     }

    proc do_Apply {p} {
        global ChannelMenu
        foreach i $ChannelMenu {variable A$i}

        switch -glob $p {
            A01      {foreach i $ChannelMenu {set A$i 1}}
            A02      {foreach i $ChannelMenu {set A$i 0}}
             A[0-9]   -
             A1[0-5]  {set i [string range $p 1 end]; set A$i [expr ([set A$i] + 1) & 1];}
            default  {puts "unknown"}
        }
     }
     
   proc UpdateModule {} {}
     
   proc do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
        variable allmodules
        variable alllinks
        variable allboards

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
        
           set w [lindex $cgidata 1]
           set i [lindex $w 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}
                
                   MODULE     {SelectFEBEXModule $i; UpdateModule}
                   ALLMODULES {set allmodules [expr ($allmodules + 1) & 1]}
                   LINK     {SelectFEBEXLink $i; UpdateModule}
                   ALLLINKS {set alllinks [expr ($alllinks + 1) & 1]}
                   BOARD     {SelectFEBEXBoard $i; UpdateModule}
                   ALLBOARDS {set allboards [expr ($allboards + 1) & 1]}

                SPECSAVE      {do_Save}
                SAVEOPT   {do_SaveOpt [lindex $w 1]}
                
               APPLY    {do_Apply [lindex $w 1]}
      
                MainLog {}
                undefined {}
                default  {InsertLog "unexpected cgi data: [lindex $w 0]  $cgidata"}
            }
         }
       }
    }    ;#  end of do_click

}  ;# end of if {$started == 0}

