
proc comment args {}

comment  {

proc do_Setting
   convert parameter (from GUI)   Pn => Pnn  to variable  Reg(nn)
   
proc do_Apply
   convert button parameter (from GUI)  A01/A02/A1-A9/ A10-A16
   
proc do_Execute
    write data from variable Reg(nn) -> firmware
    => ApplySettings
    => applysettings (for each in use module, link, board & channel
    
proc UpdateModule
    reads firmware registers to update variables Reg(nn)
    
Read_Registers
    Read all firmware registers and set variables Reg(nn) & Reg(n)
    
Update_GUI
    convert  variables Reg(nn)  ->  parameters  Pxx    in order to update GUI display

}

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

     do_click
}


if {$started == 0} {           ;#  first time load code and define local variables
    set started 1
    
    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""
    variable HelpTopic ""

    variable DoneFirmWare ""
    
    variable ExecuteRequired; set ExecuteRequired 0; ClearFooter
    
  global ModuleMenu
  global LinkMenu
  global BoardMenu
  global ChannelMenu
  
  global Options
    
    global FEBEXmodule
    global FEBEXlink
    global FEBEXboard
    global FEBEXchannel
    
    set FEBEXmodule 0
    set FEBEXlink 0
    set FEBEXboard 0
    set FEBEXchannel 0
    
    variable NUMLINKS
    set NUMLINKS 4      ;#  number of SPF links per PEXOR module
    
    variable NUMBOARDS
    set NUMBOARDS 16    ;#  number of  FEXEX4 modules supported per SPF link
    
    variable NumBoards   ;#  number of FEBEX modules active for the current SPF link
    set NumBoards 0   
    
    variable allmodules 0
    variable alllinks 0
    variable allboards 0
    variable allchannels 0
        
    variable UserLabel "test lab"

    variable numchans 16
    variable numparam 35

    foreach i $ChannelMenu {variable A$i; set A$i 1}
    foreach i $ChannelMenu {variable E$i; set E$i 1}
#    foreach i $ChannelMenu {variable H$i; set H$i 0}
    
    for {set i 1} {$i <= 8} {incr i} {variable V1$i; set V1$i 0}
    for {set i 1} {$i <= 8} {incr i} {variable V2$i; set V2$i 0}

    for {set i 1} {$i <= $numparam} {incr i} {variable P$i; set P$i 0}
    
#    P* variables hold register values and link the GUI to the code here. 
   
comment {
  P1   channel data reduction      ChDataReduction
  P2   CFD threshold               cfd_thresh
  P3   CFD enable                  cfd_enable
  P4   trigger polarity  +ve/-ve   cfd_direction
  P5   CFD filter threshold        cfd_filt_thresh
  P6   CFD delay                   cfd_delay
  P7   trigger/cfd mode            cfd_mode
  P8   CFD moving average          cfd_mavg
  P9   pretrigger delay            TrigDelay
  P11  trace length                TraceLength
  P10  test register (FEBEX)       Test
  P12  trigger control mode         expld_mode
  P13  trigger formwarding          expld_cfdfwd
  P14   MWD                    mwd_m
  P15   MWD                    mwd_l
  P16   MWD                    mwd_torr
  P17   MWD                    mwd_b
  P18   MWD                    mwd_o
  P19   MWD                    mwd_ctd
  P20   trigger matrix window      tm_window
  P21   trigger matrix window      tm_row
#  P22   moving window          mwd_pt
#  P23   moving window          mwd_tsh
#  P24   moving window          mwd_tsl
  P25   moving window          mwd_ues
  P31   MWD                    mwd_test
  P32   MWD                    mwd_gpon
  P33   MWD                    mwd_mcnt_reg
  
  P26   Option  TorB
  P27   Option  mark_sp
  P28   Option  Read_MWD
  P29   Option  MagF
  P30   Option  WaveSel
  P34   Option  pad
  P35   Option  Global Trigger
}  
    variable CFDMAvg  [list 0 2 4 8 16 32 64 128]

    set P1 $Reg(ChDataReduction)       ;# channel data reduction
    set P2 $Reg(cfd_thresh)      ;# CFD threshold
    set P3 $Reg(cfd_enable)      ;# CFD enable
    set P4 $Reg(cfd_direction)   ;# trigger polarity
    set P5 $Reg(cfd_filt_thresh) ;# CFD filter threshold
    set P6 $Reg(cfd_delay)       ;# CFD delay
    set P7 $Reg(cfd_mode)        ;# CFD mode
    
    set P8 [lsearch $CFDMAvg $Reg(cfd_mavg)]     ;# CFD moving average
    set P9 $Reg(TrigDelay)                       ;#  pre trigger position

    set P10 $Reg(Test)                            ;# test register 
    set P11 $Reg(TraceLength)                     ;# trace length
         
    set P12 $Reg(expld_mode)      ;# exploder bypass  trigger mode select
    set P13 $Reg(expld_cfdfwd)    ;# exploder bypass  trigger forwarding
    
    set P14 $Reg(mwd_m)         ;# MWD length of step signal from exponential tail (samples)
    set P15 $Reg(mwd_l)
    set P16 $Reg(mwd_torr)
    set P17 $Reg(mwd_b)
    set P18 $Reg(mwd_o)
    set P19 $Reg(mwd_ctd)
    
    set P20 $Reg(tm_window)    ;#   Trigger Matrix
    set P21 $Reg(tm_row)

#    set P22 $Reg(mwd_pt)
#    set P23 $Reg(mwd_tsh)
#    set P24 $Reg(mwd_tsl)

     set P22  0; set P23  0; set P24  0;     #  no longer used
    set P25 $Reg(mwd_ues)
    
    set P26 $Reg(D6)
    set P27 $Reg(D5)
    set P28 $Reg(D4)
    set P29 $Reg(D03)
    set P30 $Reg(D7)
    set P34 $Reg(D9)
    set P35 $Reg(D10)
    
    set P31 $Reg(mwd_test)
    set P32 $Reg(mwd_gpon)
    set P33 $Reg(mwd_mcnt_reg)

 
   
     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

   proc import_HardWare {} {

     global FEBEXmodule
     global FEBEXlink
     global FEBEXboard
     global FEBEXchannel

     set FEBEXboard [GetFEBEXBoard]
     set FEBEXlink  [GetFEBEXLink]
     set FEBEXmodule [GetFEBEXModule]
     set FEBEXchannel [GetFEBEXChannel]
     
#        InsertLog "ReadFEBEXRegister $FEBEXlink $FEBEXboard ChDataReduction"
        set rc [catch {ReadFEBEXRegister $FEBEXlink $FEBEXboard ChDataReduction} m]
#        InsertLog "ChDataReduction => $rc $m"
        set Reg(ChDataReduction) $m
     
#    software reset for MWD module

         set reg mwd_m
         set Reg($reg) 597

         Write_4A_Register $reg [set Reg($reg)]
         
         set reg mwd_l
         set Reg($reg) 447

         Write_4A_Register $reg [set Reg($reg)]
         
         set reg mwd_torr
         set Reg($reg) 0x386e

         Write_4A_Register $reg [set Reg($reg)]
         
         set reg mwd_b
         set Reg($reg) 6

         Write_4A_Register $reg [set Reg($reg)]
         
         set reg mwd_O
         set Reg($reg) 0xa0

         Write_4A_Register $reg [set Reg($reg)]
         
         set reg mwd_ctd
         set Reg($reg) 1050

         Write_4A_Register $reg [set Reg($reg)]
         
         set reg mwd_pt
         set Reg($reg) 4095

         Write_4A_Register $reg [set Reg($reg)]
         
         set reg mwd_tsh
         set Reg($reg) 0xffffff

         Write_4A_Register $reg [set Reg($reg)]
         
         set reg mwd_tsl
         set Reg($reg) 0xff

         Write_4A_Register $reg [set Reg($reg)]
         
         set reg mwd_ues
         set Reg($reg) 0

         Write_4A_Register $reg [set Reg($reg)]
         
         set reg mwd_test
         set Reg($reg) 0

         Write_4A_Register $reg [set Reg($reg)]
   }

   proc export_HardWare {} {

     global FEBEXmodule
     global FEBEXlink
     global FEBEXboard
     global FEBEXchannel

     SelectFEBEXBoard $FEBEXboard
     SelectFEBEXLink  $FEBEXlink
     SelectFEBEXModule $FEBEXmodule
     SelectFEBEXChannel $FEBEXchannel
     
         set i $FEBEXchannel; 
         variable A$i; 
         do_Button A$i; 
         UpdateModule; 
         
         variable ExecuteRequired; 
         set ExecuteRequired 0; 
         
         ClearFooter
         
   }

    set P14 $Reg(mwd_m)         ;# MWD length of step signal from exponential tail (samples)
    set P15 $Reg(mwd_l)
    set P16 $Reg(mwd_torr)
    set P17 $Reg(mwd_b)
    set P18 $Reg(mwd_o)
    set P19 $Reg(mwd_ctd)
    
#    These initial procedures  (as far as Read_Registers)  are intended for test and debug purposes 
#       and play no part in the actual control of the hardware

   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable DebugFlag
        variable Rmsg
        variable Wmsg
        variable allmodules
        variable alllinks
        variable allboards
        variable allchannels
        variable ExecuteRequired
        
        global MIDAS_FEBEXAccessServer_Exists
        global FEBEXAccessServerHost
        
        global RegList1  RegList2  RegList3 RegList4  RegList5
        
        global FEBEXmodule
        global FEBEXlink
        global FEBEXboard
        global FEBEXchannel 
        
        global LinkMenu
        global BoardMenu
        global ChannelMenu
        global ModuleMenu
        
#       import_HardWare
       
        InsertLog "MIDAS_FEBEXAccessServer_Exists = $MIDAS_FEBEXAccessServer_Exists;  FEBEXAccessServerHost = $FEBEXAccessServerHost"
        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag; DebugFlag=$DebugFlag"
        InsertLog "FEBEXmodule=$FEBEXmodule; link=$FEBEXlink; board=$FEBEXboard; channel=$FEBEXchannel"
        InsertLog "GetFEBEXModule=[GetFEBEXModule]; link=[GetFEBEXLink]; board=[GetFEBEXBoard]; channel=[GetFEBEXChannel]"
        InsertLog "linkmenu = $LinkMenu;  boardmenu = $BoardMenu"
        InsertLog "allmodules=$allmodules; allboards=$allboards; alllinks=$alllinks; allchannels=$allchannels"
        InsertLog "Rmsg=$Rmsg"
        InsertLog "Wmsg=$Wmsg"
        
        InsertLog "ExecuteRequired = $ExecuteRequired"
        
        foreach i $ChannelMenu {variable A$i; InsertLog "A$i = [set A$i]"}
        foreach i $ChannelMenu {variable E$i; InsertLog "E$i = [set E$i]"}
        
        
    set rc [catch {::FEBEX_TriggerMatrix::do_Setall 0 0} m]
   InsertLog "do_Setall => $rc $m"

    set rc [catch {::FEBEX_TriggerMatrix::do_Apply 16 SAQU 0x555} m]
   InsertLog "do_Apply => $rc $m"


    set rc [catch {::FEBEX_TriggerMatrix::UpdateModule; ::FEBEX_TriggerMatrix::do_DBUpdate} m]
   InsertLog "do_Apply => $rc $m"

        InsertLog "RegList1  $RegList1"
        InsertLog "RegList2  $RegList2"
        InsertLog "RegList3  $RegList3"
        InsertLog "RegList4  $RegList4"
        InsertLog "RegList5  $RegList5"
        
        set Reg D7
        set vl 4000
        set rc [catch {WriteFEBEX4ARegister [GetFEBEXLink] [GetFEBEXBoard] 0 $Reg  $vl} m]
        InsertLog "Write $Reg $vl  :   rc=$rc => $m"

        set Reg D7
        set vl 0
        set rc [catch {ReadFEBEX4ARegister [GetFEBEXLink] [GetFEBEXBoard] 0 $Reg} m]
        InsertLog "Read $Reg  :  rc=$rc => $m"

        InsertLog "do_Setting"
        do_Setting rangeInputSP6 130
        
        InsertLog "Write_4A_Register"
        Write_4A_Register cfd_delay 130
        
        InsertLog "ReadFEBEX4ARegister"
        set rc [catch {ReadFEBEX4ARegister [GetFEBEXLink] [GetFEBEXBoard] 0 cfd_delay} m]
        if {[llength $m] == 1} {set RData $m} else {set RData [lindex $m 1]}
        InsertLog "cfd_delay R => $rc [llength $m] $m"
        
        InsertLog "do_Setting"
        do_Setting rangeInputSP12 1
        
        InsertLog "Write_4A_Register"
        Write_4A_Register expld_mode 1
        
        InsertLog "ReadFEBEX4ARegister  expld_mode"
        set rc [catch {ReadFEBEX4ARegister [GetFEBEXLink] [GetFEBEXBoard] 0 expld_mode} m]
        InsertLog "expld_mode R => $rc [llength $m] $m"
        
        InsertLog "ReadFEBEX4ARegister  expld_cfdfwd"
        set rc [catch {ReadFEBEX4ARegister [GetFEBEXLink] [GetFEBEXBoard] 0 expld_cfdfwd} m]
        InsertLog "expld_cfdfwd R => $rc [llength $m] $m"

   }
   
   
   proc ShowRegisters {} {
      global RegList1 RegList2 RegList3 RegList4 RegList5
      global Reg

      InsertLog "showing registers"
      
       foreach reg $RegList1 {
           InsertLog "Register $reg = [expr [set Reg($reg)]] [format "0x%08x" [set Reg($reg)]]  "
       }      

       foreach reg $RegList2 {   ;# these are the CFD firmware registers
          InsertLog "Register $reg = [expr [set Reg($reg)]] [format "0x%08x" [set Reg($reg)]]  "
       }  
       
       foreach reg $RegList3 {   ;# these are the Exploder Bypass firmware registers
          InsertLog "Register $reg = [expr [set Reg($reg)]] [format "0x%08x" [set Reg($reg)]]  "
       }  
       
       foreach reg $RegList4 {   ;# these are the Trigger Matrix firmware registers
          InsertLog "Register $reg = [expr [set Reg($reg)]] [format "0x%08x" [set Reg($reg)]]  "
       }  
       
       foreach reg $RegList5 {   ;# these are the MWD firmware registers
          InsertLog "Register $reg = [expr [set Reg($reg)]] [format "0x%08x" [set Reg($reg)]]  "
       }  
   
      InsertLog "Done"
   
   }
   
 
   proc ReadAndShowRegisters {} {
 
       Read_Registers
       ShowRegisters
   }
   
   
   proc ShowParameters {} {
      global ChannelMenu
      variable numparam

    for {set i 1} {$i <= $numparam} {incr i} {variable P$i}
    foreach i $ChannelMenu {variable A$i}
    foreach i $ChannelMenu {variable E$i}
#    foreach i $ChannelMenu {variable H$i}

  InsertLog "showing GUI parameters"

       for {set i 1} {$i <= $numparam} {incr i} {
          InsertLog "P$i = [set P$i]"
       }
       foreach i $ChannelMenu {
          InsertLog "A$i = [set A$i]"
       }
       foreach i $ChannelMenu {
          InsertLog "E$i = [set E$i]"
       }
#       foreach i $ChannelMenu {
#          InsertLog "H$i = [set H$i]"
#       }
   
       
  InsertLog "Done"
   
   }
   
   proc Initialise_GUI  {} {
      global ChannelMenu
   
    foreach i $ChannelMenu {variable A$i}
   
      UpdateModule
     
       set A 0
       foreach i $ChannelMenu {      
          set A [expr $A + [set A$i]]
       }
       if {$A == 0} {       ;#  no channel active  - make current channel active
          set A$i 1
       }
       
      Update_GUI
      
      variable ExecuteRequired; set ExecuteRequired 0; ClearFooter
   
   }
   
   proc update_HardWare {} {
       global Options
       global LinkMenu
       global FEBEXlink 
       global BoardMenu
       global FEBEXboard 
       variable NumBoards
       variable NUMLINKS
       variable NUMBOARDS
       
    LoadOptions
    
    set FEBEXlinkMenu {}
    for {set l 0} {$l < $NUMLINKS} {incr l} {
        if {$Options(FEBEX.Link[set l]NumBoards) > 0} {lappend FEBEXlinkMenu $l}
    }

    set l $FEBEXlink
    if {$Options(FEBEX.Link[set l]NumBoards) == 0} {set FEBEXlink [first $FEBEXlinkMenu]}
    set l $FEBEXlink
    
    set FEBEXboardMenu {}
    for {set b 0} {$b < $Options(FEBEX.Link[set l]NumBoards)} {incr b} {
       lappend FEBEXboardMenu $b
    }
    
   }


   proc Read_Registers {} {
       variable DebugFlag
    
#    read all the firmware registers
#    read the FEBEX CFD firmware registers
#    also includes Exploder Bypass functions

       global Reg
       global RegList1 RegList2 RegList3  RegList4 RegList5
       
       if {$DebugFlag != 0}  {InsertLog "Read_Registers"}
       if {$DebugFlag != 0}  {InsertLog "Read Base Registers"}
         
       set module [GetFEBEXModule]
       set link [GetFEBEXLink]
       set board [GetFEBEXBoard]
       set channel [GetFEBEXChannel]
       
       foreach reg $RegList1 { 
       
         if {$reg == "Reset"} {set Reg($reg) 0; continue}
         if {$reg == "TimeReset"} {set Reg($reg) 0; continue}
          
          set z [catch {ReadFEBEXRegister $link $board $reg} m]
          if {$z != 0} {InsertLog "Read_Registers: error reading $link $board $reg  => $m"}
          if {[llength $m] == 1} {set RData $m} else {set RData [lindex $m 1]}
          set Reg($reg) [expr $RData]
          if {$DebugFlag != 0}  {InsertLog "Read_Registers: ReadFEBEXRegister $link $board $reg => ([format \"0x%08x\" [set Reg($reg)]])  => $m"}
       }
       
       if {$DebugFlag != 0}  {InsertLog "Read CFD Registers"}
       
       foreach reg $RegList2 {   ;#  cfd registers
          
          set z [catch {ReadFEBEX4ARegister $link $board $channel $reg} m]
          if {$z != 0} {InsertLog "Read_CFD_Registers: error reading  ReadFEBEX4ARegister $link $board $channel $reg => $m"}
          if {[llength $m] == 1} {set RData $m} else {set RData [lindex $m 1]} 
          set Reg($reg) [expr $RData & 0x0000ffff]
          if {$DebugFlag != 0}  {InsertLog "Read_CFD_Registers: ReadFEBEX4ARegister $link $board $channel $reg => ([format \"0x%08x\"  [set Reg($reg)]])  => $m"}
       }
       
       if {$DebugFlag != 0}  {InsertLog "Read Exploder Bypass Registers"}     
       
       foreach reg $RegList3 {   ;#   exploder bypass registers
          
          set z [catch {ReadFEBEX4ARegister $link $board $channel $reg} m]
          if {$z != 0} {InsertLog "Read_EXP_Registers: error reading  ReadFEBEX4ARegister $link $board $channel $reg => $m"}
          if {[llength $m] == 1} {set RData $m} else {set RData [lindex $m 1]}
          set Reg($reg) [expr $RData & 0x0000ffff]
          if {$DebugFlag != 0}  {InsertLog "Read_EXP_Registers: ReadFEBEX4ARegister $link $board $channel $reg => ([format \"0x%08x\"  [set Reg($reg)]])  => $m"}
       }
       
       foreach reg $RegList4 {   ;#   Trigger Matrix registers
          
          set z [catch {ReadFEBEX4ARegister $link $board $channel $reg} m]
          if {$z != 0} {InsertLog "Read_TM_Registers: error reading  ReadFEBEX4ARegister $link $board $channel $reg => $m"}
          if {[llength $m] == 1} {set RData $m} else {set RData [lindex $m 1]}
          set Reg($reg) [expr $RData & 0x0000ffff]
          if {$DebugFlag != 0}  {InsertLog "Read_TM_Registers: ReadFEBEX4ARegister $link $board $channel $reg => ([format \"0x%08x\"  [set Reg($reg)]])  => $m"}
       }

       foreach reg $RegList5 {   ;#   MWD registers
          
          set z [catch {ReadFEBEX4ARegister $link $board $channel $reg} m]
          if {$z != 0} {InsertLog "Read_MWD_Registers: error reading  ReadFEBEX4ARegister $link $board $channel $reg => $m"}
          if {[llength $m] == 1} {set RData $m} else {set RData [lindex $m 1]}
          set Reg($reg) [expr $RData & 0x0000ffff]
          if {$DebugFlag != 0}  {InsertLog "Read_MWD_Registers: ReadFEBEX4ARegister $link $board $channel $reg => ([format \"0x%08x\"  [set Reg($reg)]])  => $m"}
       }


       if {$DebugFlag != 0}  {InsertLog "Done"}
       
    }
    
    proc Write_Register {reg value} {
       variable DebugFlag
       global Reg
       
#    write the firmware register $reg  having value $value
       
       if {$DebugFlag != 0}  {InsertLog "Write_Register  $reg $value [set Reg($reg)] "}
       
       set module [GetFEBEXModule]
       set link [GetFEBEXLink]
       set board [GetFEBEXBoard]
       set channel [GetFEBEXChannel]

          set z [catch {WriteFEBEXRegister $link $board $reg $value} m]
          if {$z != 0} {InsertLog "Write_Register: error writing $link $board $reg $value=> $m"; set m 0}
          if {$DebugFlag != 0}  {InsertLog "Write_Register: WriteFEBEXRegister  $link $board $reg $value => $m"}
          set Reg($reg) $value
       
       if {$DebugFlag != 0}  {InsertLog "Done"}
       
    }
    
    proc Write_4A_Register {reg value} {
       variable DebugFlag
       global Reg
    
#    write the FEBEX CFD firmware register $register having value $value
#    also includes Exploder Bypass functions also TM & MWD

       if {$DebugFlag != 0}  {InsertLog "Write_4A_Register  $reg $value [set Reg($reg)] "}

       set module [GetFEBEXModule]
       set link [GetFEBEXLink]
       set board [GetFEBEXBoard]
       set channel [GetFEBEXChannel]  
       
          set z [catch {WriteFEBEX4ARegister $link $board $channel $reg $value} m]
          if {$z != 0} {InsertLog "Write_4A_Register: error writing $link $board $channel $reg) [format "0x%08x" $value] => $m"; set m 0}
          if {$DebugFlag != 0}  {InsertLog "Write_4A_Register: WriteFEBEX4ARegister  $link $board $channel $reg [format "0x%08x" $value] => $m"}
          set Reg($reg) $value
       
       if {$DebugFlag != 0}  {InsertLog "Done"}
       
    }

   proc Update_GUI {} {
       variable DebugFlag
       global Reg
       global ChannelMenu
       
       variable numparam
       variable CFDMAvg

    
     if {$DebugFlag != 0}  {InsertLog "Update_GUI"}

#    convert register vales  Reg back to Pnn parameters which will update the GUI display

    for {set i 1} {$i <= $numparam} {incr i} {variable P$i}
#    foreach i $ChannelMenu {variable H$i} 

    set P1 $Reg(ChDataReduction)       ;# channel data reduction
    set P2 $Reg(cfd_thresh)      ;# CFD threshold
    set P3 $Reg(cfd_enable)      ;# CFD enable
    set P4 $Reg(cfd_direction)   ;# trigger polarity
    set P5 $Reg(cfd_filt_thresh) ;# CFD filter threshold
    set P6 $Reg(cfd_delay)       ;# CFD delay
    set P7 $Reg(cfd_mode)        ;# CFD mode
    set P8 [lsearch $CFDMAvg $Reg(cfd_mavg)]     ;# CFD moving average
    set P9 $Reg(TrigDelay)                       ;#  pre trigger position

    set P10 $Reg(Test)                            ;# test register 
    set P11 $Reg(TraceLength)                     ;# trace length
         
    set P12 $Reg(expld_mode)      ;# exploder bypass  trigger mode select
    set P13 $Reg(expld_cfdfwd)    ;# exploder bypass  trigger forwarding
    
    set P14 $Reg(mwd_m)
    set P15 $Reg(mwd_l)
    set P16 $Reg(mwd_torr)
    set P17 $Reg(mwd_b)
    set P18 $Reg(mwd_o)
    set P19 $Reg(mwd_ctd)
    
    set P20 $Reg(tm_window)  
    
    set P22 $Reg(mwd_pt)
    set P23 $Reg(mwd_tsh)
    set P24 $Reg(mwd_tsl)
    set P25 $Reg(mwd_ues)
    
    set P26 [expr ($Reg(mwd_o) >> 6) & 1]
    set P27 [expr ($Reg(mwd_o) >> 5) & 1]
    set P28 [expr ($Reg(mwd_o) >> 4) & 1]
    set P29 [expr $Reg(mwd_o) & 15]
    set P30 [expr ($Reg(mwd_o) >> 7) & 3]
    set P34 [expr ($Reg(mwd_o) >> 9) & 1]
    set P35 [expr ($Reg(mwd_o) >> 10) & 1]

    
    set P31 $Reg(mwd_test)
    set P32 $Reg(mwd_gpon)
    set P33 $Reg(mwd_mcnt_reg)
    

     for {set i 1} {$i <= $numparam} {incr i}  {set P$i [expr [set P$i]]}   ;# convert value to decimal 
         
#        set channel [GetFEBEXChannel]        ;#  update Threshold parameter for FEBEX firmware
      
        if {$DebugFlag != 0}  {InsertLog "Done"}

   }

    proc ApplySettings {} {
       global Reg
       global RegList1 RegList2 RegList3 RegList4 RegList5
       global ModuleMenu LinkMenu BoardMenu ChannelMenu
       variable DebugFlag
    
#    called from the GUI to apply setting for all required  modules; boards & channels
       
       if {$DebugFlag != 0}  {InsertLog "ApplySettings"}
 
       set module [GetFEBEXModule]
       set link [GetFEBEXLink]
       set board [GetFEBEXBoard]
       set channel [GetFEBEXChannel]

       set allmodules $::febexU::allmodules
       set alllinks $::febexU::alllinks
       set allboards $::febexU::allboards

       set save1 [GetFEBEXLink]
       set save2 [GetFEBEXBoard]
       set save3 [GetFEBEXChannel]
       
       set f 0

       foreach link $LinkMenu  {
         if {$alllinks == 0 && $link != [GetFEBEXLink]} {continue}
         if {$link != [GetFEBEXLink]} {SelectFEBEXLink $module}
         foreach board $BoardMenu {
           if {$allboards == 0 && $board != [GetFEBEXBoard]} {continue}
           if {$board != [GetFEBEXBoard]} {SelectFEBEXBoard $board}
           
           foreach reg $RegList1 { 
                 Write_Register $reg [set Reg($reg)]
           }       
           
           foreach reg $RegList3 { 
                 Write_4A_Register $reg [set Reg($reg)]
           }   
           
           foreach reg $RegList4 { 
                 Write_4A_Register $reg [set Reg($reg)]
           }  
           
           foreach channel $ChannelMenu {
             if {$channel != [GetFEBEXChannel]} {SelectFEBEXChannel $channel}
             variable A$channel
             if {[set A$channel] == 1} {

                if {$DebugFlag != 0}  {InsertLog "Update module=$module board=$board channel=$channel"}
                incr f
                
                foreach reg $RegList2 { 
                      Write_4A_Register $reg [set Reg($reg)]
                }  
                
                foreach reg $RegList5 { 
                      Write_4A_Register $reg [set Reg($reg)]
                }  
             }
           }   ;# end of foreach channel
           
          UpdateModule
           
         }   ;#  end of foreach board
       }
       
       SelectFEBEXLink $save1
       SelectFEBEXBoard $save2
       SelectFEBEXChannel $save3
       
#      if {$f > 0} {InsertLog "Done - settings applied to $f channels"}
      if {$f == 0} {InsertLog "Warning - no channels active"}
      
      if {$DebugFlag != 0}  {InsertLog "Done"}
      
    }

    proc UpdateModule {} {
        variable DebugFlag
    
#    read the contents of all registers for the current ADC (module, link, board & channel) to update the GUI 

         if {$DebugFlag != 0}  {InsertLog "UpdateModule"}
         
#        import_HardWare

         Read_Registers
         Update_GUI
        
         if {$DebugFlag != 0}  {InsertLog "Done"}

     }

    proc do_Setting {p vl} {
        variable DebugFlag
    
    if {$DebugFlag != 0}  {InsertLog "do_Setting $p = $vl"}

#    handle the information received from the GUI for each setting changed
#    convert variable name from new to previous scheme

       global Reg
       variable numparam
       variable CFDMAvg
   
       for {set i 1} {$i <= $numparam} {incr i} {variable P$i}

        switch -glob $p {
           Choice*      {set p [string range $p 6 end]}
           rangeInputS* {set p [string range $p 11 end]}
           textInputS*  {set p [string range $p 10 end]}
           Text*        {set p [string range $p 4 end]}
           Number*      {set p [string range $p 6 end]}
        }
        
        set $p $vl    ;#  store the received data in a P** variable
        
        if {$DebugFlag != 0}  {InsertLog "$p => [set $p]"}
        
        if {$P24 == ""} {set P24 0xff}
        if {$P23 == ""} {set P23 0xffffff}
        
comment {
  P1   channel data reduction      ChDataReduction
  P2   CFD threshold               cfd_thresh
  P3   CFD enable                  cfd_enable
  P4   trigger polarity  +ve/-ve   cfd_direction
  P5   CFD filter threshold        cfd_filt_thresh
  P6   CFD delay                   cfd_delay
  P7   trigger/cfd mode            cfd_mode
  P8   CFD moving average          cfd_mavg
  P9   pretrigger delay            TrigDelay
  P11  trace length                TraceLength
  P10  test register (FEBEX)       Test
  P12  trigger control mode         expld_mode
  P13  trigger formwarding          expld_cfdfwd
  P14   MWD                    mwd_m
  P15   MWD                    mwd_l
  P16   MWD                    mwd_torr
  P17   MWD                    mwd_b
  P18   MWD                    mwd_o
  P19   MWD                    mwd_ctd
  P20   trigger matrix window      tm_window
  P21   trigger matrix window      tm_row
  P22   moving window          mwd_pt
  P23   moving window          mwd_tsh
  P24   moving window          mwd_tsl
  P25   moving window          mwd_ues
  
  P26   Option  TorB
  P27   Option  mark_sp
  P28   Option  Read_MWD
  P29   Option  MagF
  P30   Option  WaveSel
  P34   Option  pad_reg
  P35   Option  GT
  
  P31   moving window      mwd_test
  P32   moving window      mwd_gpon
  P33   moving window      mwd_mcnt_reg 
  
}
      
#    settings which correspond to a register

      switch  $p {
         P1  {set Reg(ChDataReduction) $P1}
         P2  {set Reg(cfd_thresh) $P2}
         P3  {set Reg(cfd_enable) $P3}
         P4  {set Reg(cfd_direction) $P4}
         P5  {set Reg(cfd_filt_thresh) $P5}
         P6  {set Reg(cfd_delay) $P6}
         P7  {set Reg(cfd_mode) $P7}
         P8  {set P8 [lindex $CFDMAvg $P8]; set Reg(cfd_mavg) $P8}
         P9  {set Reg(TrigDelay) $P9}
         P10 {set Reg(Test) $P10}
         P11 {set Reg(TraceLength) $P11}
         P12 {set Reg(expld_mode) $P12}
         P13 {set Reg(expld_cfdfwd) $P13}
         P14 {set Reg(mwd_m) $P14}
         P15 {set Reg(mwd_l) $P15}
         P16 {set Reg(mwd_torr) $P16}
         P17 {set Reg(mwd_b) $P17}
         P18 {
             set Reg(mwd_o) $P18
             set Reg(D10) [expr ($P18 >> 10) & 1]
             set Reg(D9) [expr ($P18 >> 9) & 1]
             set Reg(D7) [expr ($P18 >> 7) & 1]
             set Reg(D6) [expr ($P18 >> 6) & 1]
             set Reg(D5) [expr ($P18 >> 5) & 1]
             set Reg(D4) [expr ($P18 >> 4) & 1]
             set Reg(D03) [expr $P18 & 15]        
         }
         P19 {set Reg(mwd_ctd) $P19}
         P20 {set Reg(tm_window) $P20}
         P21 {set Reg(tm_row) $P21}
         P22 {set Reg(mwd_pt) $P22}
         P23 {set Reg(mwd_tsh) $P23}
         P24 {set Reg(mwd_tsl) $P24}
         P25 {set Reg(mwd_ues) $P25}
         
         P26 {set Reg(D6) $P26; set P18 [expr ($Reg(D10) << 10) + ($Reg(D9) << 9) + ($Reg(D7) << 7) + ($Reg(D6) << 6) + ($Reg(D5) << 5) + ($Reg(D4) << 4) + $Reg(D03)]; set Reg(mwd_o) $P18}
         P27 {set Reg(D5) $P27; set P18 [expr ($Reg(D10) << 10) + ($Reg(D9) << 9) + ($Reg(D7) << 7) + ($Reg(D6) << 6) + ($Reg(D5) << 5) + ($Reg(D4) << 4) + $Reg(D03)]; set Reg(mwd_o) $P18}
         P28 {set Reg(D4) $P28; set P18 [expr ($Reg(D10) << 10) + ($Reg(D9) << 9) + ($Reg(D7) << 7) + ($Reg(D6) << 6) + ($Reg(D5) << 5) + ($Reg(D4) << 4) + $Reg(D03)]; set Reg(mwd_o) $P18}
         P29 {set Reg(D03) $P29; set P18 [expr ($Reg(D10) << 10) + ($Reg(D9) << 9) + ($Reg(D7) << 7) + ($Reg(D6) << 6) + ($Reg(D5) << 5) + ($Reg(D4) << 4) + $Reg(D03)]; set Reg(mwd_o) $P18}
         P30 {set Reg(D7) $P30; set P18 [expr ($Reg(D10) << 10) + ($Reg(D9) << 9) + ($Reg(D7) << 7) + ($Reg(D6) << 6) + ($Reg(D5) << 5) + ($Reg(D4) << 4) + $Reg(D03)]; set Reg(mwd_o) $P18}
         P34 {set Reg(D9) $P34; set P18 [expr ($Reg(D10) << 10) + ($Reg(D9) << 9) + ($Reg(D7) << 7) + ($Reg(D6) << 6) + ($Reg(D5) << 5) + ($Reg(D4) << 4) + $Reg(D03)]; set Reg(mwd_o) $P18}
         P35 {set Reg(D10) $P35; set P18 [expr ($Reg(D10) << 10) + ($Reg(D9) << 9) + ($Reg(D7) << 7) + ($Reg(D6) << 6) + ($Reg(D5) << 5) + ($Reg(D4) << 4) + $Reg(D03)]; set Reg(mwd_o) $P18}


         P31 {set Reg(mwd_test) $P31}
         P32 {set Reg(mwd_gpon) $P32}
         P33 {set Reg(mwd_mcnt_reg) $P33}
                           
         default {}
         
      }
      
      variable ExecuteRequired; set ExecuteRequired 1
      
      SetFooter "There are parameter changes to be written to the FEBEX modules - Use the \"Execute\" button to apply or Use \"Discard\""
      
       if {$DebugFlag != 0}  {InsertLog "Done"}
       
#       InsertLog "$P18   $P30"
#       InsertLog "$P26  $P27  $P28  $P29  $P30  :  $Reg(D6) $Reg(D5) $Reg(D4) $Reg(D03) $Reg(D7)   :    $P18"

    }



    proc do_Button {p} {
        variable DebugFlag
        global ChannelMenu
        
        if {$DebugFlag != 0}  {InsertLog "do_Button $p"}

#       sets variables for the buttons

    foreach i $ChannelMenu {variable A$i}
    foreach i $ChannelMenu {variable E$i}    
#    foreach i $ChannelMenu {variable H$i}

      global Reg
      

        switch -glob $p {
            A01      {foreach i $ChannelMenu {set A$i 1}}
            A02      {foreach i $ChannelMenu {set A$i 0}}
             A[0-9]   -
             A1[0-5]  {set i [string range $p 1 end]; set A$i [expr ([set A$i] + 1) & 1]}
            E01      {foreach i $ChannelMenu {set E$i 1}}
            E02      {foreach i $ChannelMenu {set E$i 0}}
             E[0-9]   -
             E1[0-5]  {set i [string range $p 1 end]; set E$i [expr ([set E$i] + 1) & 1]}
#            H1[0-6]  -
#            H[1-9]    {set $p [expr ([set $p] + 1) & 1]}
#            H01      {foreach i $ChannelMenu {set H$i 1}}
#            H02      {foreach i $ChannelMenu {set H$i 0}}
            default  {puts "unknown"}
        }
        
comment {
        switch -glob $p {
           H* {
             set HP $Reg(**)
             foreach i $ChannelMenu {
                set HP [expr $HP | ([set H$i] << ($i-1))]
             }
             set Reg(**) [format "0x%02x" $HP]  ;#  set Hit Pattern Mask Register
           }
        }
}
        
      variable ExecuteRequired; set ExecuteRequired 1
      
      SetFooter "There are parameter changes to be written to the FEBEX modules - Use the \"Execute\" button to apply or Use \"Discard\""

        if {$DebugFlag != 0}  {InsertLog "Done"}
          
    }

    proc do_Execute {i} {
        variable DebugFlag

        if {$DebugFlag != 0}  {InsertLog "do_Execute $i"}
        
     if {$i == "A00"} {
    
#      write the register data from variables Reg(nn) to the correspond firmware register    

        ApplySettings         ;#  continue for all other settings 
     }
        
      variable ExecuteRequired; set ExecuteRequired 0
      
      ClearFooter
      
        if {$DebugFlag != 0}  {InsertLog "Execute completed"}
    }
    

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable DebugFlag
       variable ShowLogFlag
       variable allmodules
       variable alllinks
       variable allboards
       variable allchannels
     global FEBEXmodule
     global FEBEXlink
     global FEBEXboard
     global FEBEXchannel
       variable ExecuteRequired

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
      
               set w [lindex $cgidata 1]
               set i [second [lindex $cgidata 1]]
               set vl [third [lindex $cgidata 1]]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {UpdateModule}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   DEBUGON    {set DebugFlag 1}
                   DEBUGOFF   {set DebugFlag 0}
                   
   		   HELP     {variable HelpTopic; set HelpTopic Help; do_help}                

                   MODULE     {SelectFEBEXModule $i; UpdateModule}
                   ALLMODULES {set allmodules [expr ($allmodules + 1) & 1]}
                   LINK     {SelectFEBEXLink $i; UpdateModule}
                   ALLLINKS {set alllinks [expr ($alllinks + 1) & 1]}
                   BOARD     {SelectFEBEXBoard $i; UpdateModule}
                   ALLBOARDS {set allboards [expr ($allboards + 1) & 1]}
                   CHANNEL   {SelectFEBEXChannel $i; set FEBEXchannel $i; do_Button A$i; UpdateModule}
                   ALLCHANNELS {set allchannels [expr ($allchannels + 1) & 1]}

                   RANGE -
                   TEXT -
                   SETTINGS  {UpdateModule; do_Setting $i $vl}
                   
                   BUTTON    {UpdateModule; do_Button $i}
                   EXECUTE   {set z [catch {do_Execute $i} m]; InsertLog "do_Execute returned $z $m"}
                   
                   EXPERT    {$i}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
            }
         }
      
      if {$ExecuteRequired != 0} {set z [catch {do_Execute "A00"} m]; InsertLog "do_Execute returned $z $m"}  
      
#      UpdateModule
         
      }   ;#  end of do_click 
      
      import_HardWare  ;# first time  through
#      Read_Registers
      UpdateModule
      
}       ;# end of if {$started == 0}


